const TnTPDia = "0";
const TnTPSemana = "1";
const TnTPMes = "2";
const TnTPAno = "3";
const TnTPSIM = "1";
const TnTPNAO = "0";

FormManager.afterCreateAllForms.subscribe(function () {
	let formTNDMJOBAGENDA = FormManager.byname("TNDMJOBAGENDA");

	const ConfigurarPeriodico = function () {
		let periodicoEnabled = formTNDMJOBAGENDA.fieldbyName('PERIODICO').getvalue() == TnTPSIM;

		if (!periodicoEnabled) {
			disableCheck('REPETIRSEMANA_checkbox');
			ConfigurarNenhum();
		}

		formTNDMJOBAGENDA.setvisible('REPETIRCADA', periodicoEnabled);
		formTNDMJOBAGENDA.setenabled('REPETIRCADA', periodicoEnabled);
		formTNDMJOBAGENDA.setrequired('REPETIRCADA', periodicoEnabled);

		formTNDMJOBAGENDA.setvisible('PERIODICIDADE', periodicoEnabled);
		formTNDMJOBAGENDA.setenabled('PERIODICIDADE', periodicoEnabled);
		formTNDMJOBAGENDA.setrequired('PERIODICIDADE', periodicoEnabled);

		ConfigurarDiaInteiro()

	}

	const disableCheck = function (fieldName) {
		formTNDMJOBAGENDA.fields.forEach((field, index) => {
			if (field.nome.indexOf(fieldName) > -1) {
				if (!field.disabled()) {
					formTNDMJOBAGENDA.setfieldvalue(field.nome, false);
					field.componente.change();
				}
			}
		});
	}

	const ConfigurarNenhum = function () {
		disableCheck('REPETIRSEMANA_checkbox');
		$("#ctrlREPETIRMES").html("");

		if (formTNDMJOBAGENDA.fieldbyName('PERIODICO').getvalue() == TnTPNAO) {
			formTNDMJOBAGENDA.fieldbyName('REPETIRCADA').setvalue(null);
		}

		formTNDMJOBAGENDA.setvisible('REPETIRMES', false);
		formTNDMJOBAGENDA.setrequired('REPETIRMES', false);

		formTNDMJOBAGENDA.setvisibleCheckListBox('REPETIRSEMANA', false);
		formTNDMJOBAGENDA.setrequired('REPETIRSEMANA', false);
	}

	const ConfigurarDiaInteiro = function () {
		let periodicoEnabled = formTNDMJOBAGENDA.fieldbyName('PERIODICO').getvalue() == TnTPSIM;

		if (periodicoEnabled) {
			formTNDMJOBAGENDA.setfieldvalue("DIAINTEIRO_checkbox_1", !periodicoEnabled);
			formTNDMJOBAGENDA.fieldbyName('REPETIRMINUTOS').setvalue(30);
		}

		formTNDMJOBAGENDA.setenabled('REPETIRMINUTOS', formTNDMJOBAGENDA.getvalue("DIAINTEIRO_checkbox_1"));
		formTNDMJOBAGENDA.setrequired('REPETIRMINUTOS', formTNDMJOBAGENDA.getvalue("DIAINTEIRO_checkbox_1"));

		formTNDMJOBAGENDA.setenabledCheckListBox("DIAINTEIRO", !periodicoEnabled)

		formTNDMJOBAGENDA.setenabled('HORARIO', (!formTNDMJOBAGENDA.getvalue("DIAINTEIRO_checkbox_1")));
		formTNDMJOBAGENDA.setvisible('HORARIO', (!formTNDMJOBAGENDA.getvalue("DIAINTEIRO_checkbox_1")));
	}

	const ConfigurarComboBox = function () {
		let AData = formTNDMJOBAGENDA.fieldbyName("DATAINICIAL").getvalue();
		let periodicoEnabled = formTNDMJOBAGENDA.fieldbyName('PERIODICO').getvalue() == TnTPSIM;

		$("#ctrlREPETIRMES").html("");
		DesabilitarActionsPadrao();

		if (AData && periodicoEnabled) {
			let ADataArray = AData.split("-");
			if (ADataArray[0] && ADataArray[1] && ADataArray[2]) {
				let Data = new Date(ADataArray[0], ADataArray[1] - 1, ADataArray[2]);
				let AValor = weekAndDay(Data);
				$("#ctrlREPETIRMES").append(`<option value="${ADataArray[2]}">Mensal no dia ${ADataArray[2]}</option>`);
				$("#ctrlREPETIRMES").append(`<option value="${AValor.diaDaSemana}#${AValor.semanaDoMes}">Mensal no(a) ${AValor.weekOfMonth}</option>`);
			}
		}
	}

	const DesabilitarActionsPadrao = function () {
		$("#btnActDataSetPostExecuteOptsTNDMJOBAGENDA").addClass("disabled");
		$("#btnActDataSetPostExecuteOptsTNDMJOBAGENDA").html("");
	}

	const weekAndDay = function (date) {
		let days = ["º Domingo", "ª Segunda-Feira", "ª Terça-Feira", "ª Quarta-Feira", "ª Quinta-Feira", "ª Sexta-Feira", "º Sábado"],
			prefixes = ["1", "2", "3", "4", "5"];

		let obj = {
			diaDaSemana: date.getDay() + 1,
			semanaDoMes: prefixes[Math.floor(date.getDate() / 7)],
			weekOfMonth: prefixes[Math.floor(date.getDate() / 7)] + " " + days[date.getDay()]
		};
		return obj;
	}

	const ConfigurarPeriodicidade = function () {
		switch (formTNDMJOBAGENDA.fieldbyName('PERIODICIDADE').getvalue()) {
			case TnTPSemana: ConfigurarSemana();
				break;
			case TnTPMes: ConfigurarMes();
				break;
			default: ConfigurarNenhum();
		}
	}

	const ConfigurarSemana = function () {
		$("#ctrlREPETIRMES").html("");
		formTNDMJOBAGENDA.setvisible('REPETIRMES', false);
		formTNDMJOBAGENDA.setrequired('REPETIRMES', false);

		formTNDMJOBAGENDA.setvisibleCheckListBox('REPETIRSEMANA', true);
		formTNDMJOBAGENDA.setrequired('REPETIRSEMANA', true);
	}

	const ConfigurarMes = function () {
		disableCheck('REPETIRSEMANA_checkbox');
		formTNDMJOBAGENDA.setvisible('REPETIRMES', true);
		formTNDMJOBAGENDA.setrequired('REPETIRMES', true);

		formTNDMJOBAGENDA.setvisibleCheckListBox('REPETIRSEMANA', false);
		formTNDMJOBAGENDA.setrequired('REPETIRSEMANA', false);
		ConfigurarComboBox();
	}

	formTNDMJOBAGENDA.getcomponent("PERIODICO").change(ConfigurarPeriodico);
	formTNDMJOBAGENDA.getcomponent("PERIODICIDADE").change(ConfigurarPeriodicidade);
	formTNDMJOBAGENDA.getcomponent("DATAINICIAL").change(ConfigurarComboBox);
	formTNDMJOBAGENDA.getcomponent("DIAINTEIRO_checkbox_1").change(ConfigurarDiaInteiro);


	if (WizardManager.context.DetalheAtivo == "TNDMJOBAGENDA") {
		formTNDMJOBAGENDA.setvalue('CODIGOJOB', WizardManager.context.Params.PCODIGOJOB);
		formTNDMJOBAGENDA.setvalue('CODIGOJOBRESULT', WizardManager.context.Params.PCODIGOJOBRESULT);
		formTNDMJOBAGENDA.fieldbyName('PERIODICO').setvalue(TnTPNAO);
		formTNDMJOBAGENDA.fieldbyName('PERIODICIDADE').setvalue(TnTPDia);
		ConfigurarPeriodico();
		ConfigurarPeriodicidade();
		DesabilitarActionsPadrao();
	}	

	formTNDMJOBAGENDA.AfterSave.subscribe((options) => {
		let wizardContext = options.wizardContext;

		if (options.success) {
			GoToWizardItem(wizardContext.DetalheProximo);
		}
	});

	formTNDMJOBAGENDA.fieldbyName('PERIODICO').setvalue(TnTPNAO);
	ConfigurarComboBox();
	ConfigurarPeriodico();
	ConfigurarDiaInteiro();

	WizardManager.setCustomEvent("TNDMJOBAGENDA", function() {
		$("#btnActDataSetPostExecuteTNDMJOBAGENDA").click();
	});

});

	$(".card-header").eq(1).hide();

	setTimeout(function () { $('#btnFiltrar').click() }, 100);

	$('#btnFiltrar').hide();

	$("#ctrlREPETIRSEMANAcheck").removeClass('checkbox-wrapper');
	$("#ctrlREPETIRSEMANAcheck").addClass('kt-checkbox-inline');