FormManager.afterCreateAllForms.subscribe(function () {
	let form = FormManager.byname('TnFpaDMAfastamento', '');
	var TipoSit = '';
	var AfastamentoProfessor = false;
	var GeraEstabil = false;

	const EnabledCampos = function () {
		var habilitar = form.getvalue('PerdeValeTransp') == 1;
		form.setenabled('QTDEVALETRANSP', habilitar);

		habilitar = (form.getvalue('CODIGOSIT') != 12);
		form.setenabled('CODIGOSIT', habilitar);
		form.setenabled('DATATERMINO', habilitar);

		var AAtivar = (TipoSit == '27') || (TipoSit == '99');

		form.setenabled('QTDEHORAFALTA', AAtivar && !(AfastamentoProfessor));
		form.setenabled('PERDE13', AAtivar);
		form.setenabled('PERDEVALETRANSP', AAtivar);
		form.setenabled('QTDEVALETRANSP', AAtivar);
		form.setenabled('PERDEDSR', AAtivar);
		form.setenabled('PERDEFERIAS', AAtivar);

		AAtivar = ((TipoSit == '14') || (TipoSit == '26')) && (form.configextra.gProrrogaLicMat == '1');
		form.setenabled('TIPOPRORROG', AAtivar);

		AAtivar = (TipoSit == '14') && (form.getvalue('TIPOPRORROG') >= 0);
		form.setenabled('CODIGOSITPRORROGALICMAT', AAtivar);

		AAtivar = ((TipoSit == '03') || (TipoSit == '04')) || (TipoSit == '') || (TipoSit == '37');
		form.setenabled('DIASLICMEDICA', AAtivar);

		AAtivar = !((TipoSit == '07') || (form.getvalue('CODIGOSIT') == 12));
		form.setenabled('DATATERMINO', AAtivar);
		form.setrequired('DATATERMINO', AAtivar);
		form.setenabled('HORATERMINO', AAtivar);
		form.setenabled('DATAPREVTERMINO', AAtivar);
		form.setenabled('EXAMERETORNO', AAtivar);

		controlarCamposEstabilidade();

		AAtivar = (TipoSit == '06') || (TipoSit == '14');
		form.setenabled('DATAPARTO', AAtivar);

		if (AfastamentoProfessor) {
			HabilitarDetalhe('TnFpaDMAfastamentoProf', '');
		} else {
			DesabilitarDetalhe('TnFpaDMAfastamentoProf', '');
		}
	}

	const AtribuirEventos = function () {
		form.getcomponent('PERDEVALETRANSP').change(EnabledCampos);
		form.getcomponent('CODIGOSIT').change(OnCodigoSitChange);
		form.getcomponent('DATAAFAST').change(requestAfastamento);
	}

	const controlarCamposEstabilidade = function () {
		form.setenabled('DATAINICIALESTABIL', GeraEstabil);
		form.setenabled('CODIGOESTABIL', GeraEstabil);
		form.setenabled('DATAFINALESTABIL', GeraEstabil);
		form.setenabled('CODIGOMOTIVO', GeraEstabil);
	}

	const OnCodigoSitChange = function () {
		if (form.getvalue('CODIGOSIT') != '') {

			$achave = (form.getvalue('CODIGOSIT') == '') ? -1 : form.getvalue('CODIGOSIT');

			AJaxCadastroExecuteMethodGetProperty('TnFpaDMAfastamento', 'PegaTipoSit', $achave, '', (retorno) => {
				TipoSit = retorno.data.result;
				EnabledCampos();
			});


			$achave = ((form.getvalue('CODIGOSIT') == '') ? -1 : form.getvalue('CODIGOSIT')) + ';' +
				((form.getvalue('DATAPARTO') == '') ? 'true' : 'false');
			AJaxCadastroExecuteMethodGetProperty('TnFpaDMAfastamento', 'GerarEstabilidade', $achave, '', (retorno) => {
				GeraEstabil = retorno.data.result;
				controlarCamposEstabilidade();
			});
		}
	}

	const requestAfastamento = function () {
		if ((form.getvalue('CODIGOSIT') != '') &&
			(form.getvalue('CODIGOFUNCCONTR') != '') &&
			(form.getvalue('DATAAFAST') != '')) {
			if (form.getvalue('CODIGOEMPRESA') == '') {
				$achave = SessionManager.selecao.CODIGOEMPRESA + ';';
			} else {
				$achave = form.getvalue('CODIGOEMPRESA') + ';';
			}
			$achave = $achave +
				form.getvalue('CODIGOFUNCCONTR') + ';' +
				form.getvalue('CODIGOSIT') + ';' +
				form.getvalue('DATAAFAST');

			AJaxCadastroExecuteMethodGetProperty('TnFpaDMAfastamento', 'ExibirDetalheAfastamentoProfessor', $achave, '', (retorno) => {
				AfastamentoProfessor = retorno.data.result;
				EnabledCampos();
			});
		}
	}

	const DoBeforePost = function () {
		KTApp.blockPage();

		var d = $.Deferred();

		let ACodigoEmpresa = form.getvalue('CODIGOEMPRESA');
		let ACodigoFuncContr = form.getvalue('CODIGOFUNCCONTR');
		let AData = form.getvalue('DATAAFAST');

		BuscarDadosPeriodoAquisitivo(ACodigoEmpresa, ACodigoFuncContr, AData).done(() => {
			d.resolve();
			KTApp.unblockPage();
		});

		return d.promise();
	}

	const DoAfterPost = function () {
		AbrirCadastroPeriodoAquis();
	}

	form.BeforeDelete = DoBeforeDeleteAfastamento;
	form.AfterDelete = DoAfterDeleteAfastamento;
	form.BeforePost = DoBeforePost;
	form.AfterPost = DoAfterPost;

	EnabledCampos();
	AtribuirEventos();
});