FormManager.afterCreateAllForms.subscribe(function () {
    let form = FormManager.byname('TnFpaDMPeriodoAquis', '');
    form.AfterLoadData = DoAfterLoadData;
    form.getcomponent('CODIGOFUNCCONTR').change(DoChangeCodigoFuncContr);
    form.getcomponent('DATAINICIAL').blur(DoBlurDataInicial);

    const PERIODO_ABERTO = 1;

    function DoAfterLoadData() {
        if (form.getvalue('SITPERIODO') == PERIODO_ABERTO) {        
            KTApp.blockPage();

            if (form.getvalue('CODIGOEMPRESA') && form.getvalue('CODIGOFUNCCONTR') && form.getvalue('DATAINICIAL') && 
                form.getvalue('DATAFINAL') && form.getvalue('DIASJAPAGOS') && form.getvalue('DIASABONO')) {
                let achave = form.getvalue('CODIGOEMPRESA') + ';' + 
                form.getvalue('CODIGOFUNCCONTR') + ';' + 
                form.getvalue('DATAINICIAL') + ';' + 
                form.getvalue('DATAFINAL') + ';' + 
                form.getvalue('DIASJAPAGOS') + ';' + 
                form.getvalue('DIASABONO');
                AJaxCadastroExecuteMethodGetProperty('TnFpaDMPeriodoAquis', 'PegarDiasPeriodoAquisAberto', achave, '', (retorno) => {
                    form.setvalue('DIASDIREITO', retorno.data.result.DiasDireito);
                    form.setvalue('DIASSALDO', retorno.data.result.DiasSaldo);
                    form.setvalue('DIASFALTASVIS', retorno.data.result.DiasFaltasVis);                
                    form.setvalue('DIASLICREMVIS', retorno.data.result.DiasLicRemVis);                
                    form.setvalue('DIASLICMATERNVIS', retorno.data.result.DiasLicMaternVis);                
                    form.setvalue('DIASSERVMILITVIS', retorno.data.result.DiasServMilitVis);                
                    form.setvalue('DIASAFASTVIS', retorno.data.result.DiasAfastVis);                
                    form.setvalue('AVOSFERIAS', retorno.data.result.AvosFerias);                
                    KTApp.unblockPage();      
                });       
            }    
        } else {
            form.setvalue('AVOSFERIAS', 0);
            form.setvalue('DIASDIREITO', 0);
            form.setvalue('DIASSALDO', 0);
            form.setvalue('DIASFALTASVIS', form.getvalue('DIASFALTAS'));
            form.setvalue('DIASAFASTVIS', form.getvalue('DIASAFAST'));
            form.setvalue('DIASLICREMVIS', form.getvalue('DIASLICREM'));
            form.setvalue('DIASLICMATERNVIS', form.getvalue('DIASLICMATERN'));
            form.setvalue('DIASLICMILITVIS', form.getvalue('DIASLICMILIT'));                
        }
    }

    function DoBlurDataInicial() {
        if (form.estado === FormState.cadInsert) {
            let ADataInicial = form.getvalue('DATAINICIAL');
            if (ADataInicial) {
                KTApp.blockPage();
            
                AJaxCadastroExecuteMethodGetProperty('TnFpaDMPeriodoAquis', 'PegarDatasApartirDe', ADataInicial, '', (retorno) => {
                    form.setvalue('DATAFINAL', retorno.data.result.DataFinal);
                    form.setvalue('DATALIMPGTO', retorno.data.result.DataLimPgto);                
                    KTApp.unblockPage();      
                }); 
            }  
        }  
        DoAfterLoadData();
    }

    function DoChangeCodigoFuncContr() {
        if (form.estado === FormState.cadInsert) {        
            form.getvalueLookup('CODIGOFUNCCONTR', 'DATAADM').done((_ADataAdm) => {
                if (_ADataAdm) {
                    if (form.getvalue('CODIGOEMPRESA') && form.getvalue('CODIGOFUNCCONTR')) {
                        KTApp.blockPage();
                                            
                        let achave = form.getvalue('CODIGOEMPRESA') + ';' + form.getvalue('CODIGOFUNCCONTR') + ';' + _ADataAdm;
                        AJaxCadastroExecuteMethodGetProperty('TnFpaDMPeriodoAquis', 'PegarDatasPeriodoAquis05', achave, '', (retorno) => {
                            form.setvalue('DATAINICIAL', retorno.data.result.DataInicial);
                            form.setvalue('DATAFINAL', retorno.data.result.DataFinal);
                            form.setvalue('DATALIMPGTO', retorno.data.result.DataLimPgto);                
                            form.setvalue('SITPERIODO', PERIODO_ABERTO);                
                            KTApp.unblockPage();      
                        });  
                    } 
                }            
            });
        } 
    }
    
});


