const fs = require('fs');
const path = require('path');

module.exports = class GenerateMustacheScriptsPartial {
	// Define `apply` as its prototype method which is supplied with compiler as its argument
	apply(compiler) {
		compiler.hooks.done.tap('generateMustacheScriptsPartial', (statsData) => {
			let stats = statsData.toJson();
			var html = '';
			
			if (!stats.errors.length) {
				stats.assets.forEach(asset => {
					if (asset.name.match(/bundle.js$|npm\.*.*\.js$/)) {
						html = html.concat(`<script src=".static/dist/${asset.name}"></script>\n`);
					}
					if (asset.name.match(/bundle.css$|npm\.*.*\.css$/)) {
						html = html.concat(`<link href=".static/dist/${asset.name}" rel="stylesheet" type="text/css">\n`);
					}
				})

				fs.writeFileSync(path.join(__dirname, '../../', 'bundledScripts.partial'), html);
			}
		});
	}
}