/* 
	Converter em classe para:
		* Conter uma referencia ao formulario em que o field se encontra. 
		* Conter uma referencia aos "controles" de cada _checkbox.
		* Inicializador que procura por algo do tipo "[create-context-menu-checkboxlist]"
*/

import FormManager from "./FormManager";

export function createContextMenu() {
	const DoSetEnabledFields = function (_AForm, _AFieldName, _AValue, _AInverter) {
		_AForm.fields.forEach((field, index) => {
			if (field.nome.indexOf(_AFieldName + '_checkbox') > -1) {
				if (!field.disabled()) {
					_AForm.setfieldvalue(field.nome, _AInverter ? !_AForm.getvalue(field.nome) : _AValue);
					field.componente.change();
				}
			}
		});
	};
	const getConfig = ({ selector }) => {
		return {
			selector,
			trigger: 'right',
			callback: function (key, options) {
				const el =  options.$trigger;
				const id = el.find('div[id*="ctrl"]').attr('id');
				const { alias, classname } = el.data();
				const form = FormManager.getFormByChildElement(el);
				const afieldname = id.substring(4, id.indexOf('check'));

				if (key === 'marcarTodos') {
					DoSetEnabledFields(form, afieldname, true);
				} 
				else if (key === 'desmarcarTodos') {
					DoSetEnabledFields(form, afieldname, false);
				} 
				else {
					DoSetEnabledFields(form, afieldname, false, true);
				}
			},
			items: {
				"marcarTodos": { name: "Marcar Todos" },
				"desmarcarTodos": { name: "Desmarcar Todos" },
				"inverterSelecao": { name: "Inverter Seleção" }
			}
		}
	};

	
	$.contextMenu(getConfig({
		selector: '.ntcCheckListBox',
	}));

	$.contextMenu(getConfig({
		selector: '.ntcCheckListBoxScroll',
	}));

	$.contextMenu(getConfig({
		selector: '.ntcCheckListBoxHorizontal'
	}));
}