const ActionAviso = ({ event, scope }) => {
    const target = event.currentTarget;

    let items = getSpanText(scope);

    if (!$(target).data('bs.popover')) {
        $(target).popover({
            content: getPopoverBody(items, target),
            title: '',
            placement: 'bottom',
            trigger: 'manual',
            sanitize: false,
            html: true
        })

        setTimeout(() => $(target).popover('update')) // First time position update for items height > 300
    }

    $(target).popover('toggle')
}

export const getPopoverBody = (items, popover) => {
    let closeBtn = getCloseBtn(popover);
    
    let divWrapper = $('<div class="d-flex flex-row-reverse">');

    let messageContainer = $('<ul class="workspace-notification">');

    let listItems = items.map(text => {
        let li = $('<li class="workspace-notification__item">');
        let prepend = $('<span class="workspace-notification__item-prepend d-flex pr-2 align-items-center">')
        let icon = $('<i class="las la-exclamation-triangle" style="color: var(--orange-q)">');
        let span = $('<span class="workspace-notification__item-text">').append(text);

        return li.append([prepend.append(icon), span]);
    });

    messageContainer.append(listItems);

    setTimeout(() => {
        KTUtil.scrollInit(messageContainer.get(0), {
            height: () => Math.min((messageContainer.height() ?? 50), 300)
        });
    })

    return divWrapper
        .append(closeBtn)
        .append(messageContainer)
}

const getCloseBtn = (popover) => {
    return $('<span class="mb-auto" style="cursor: pointer">')
        .append('<i class="las la-times"></i>')
        .on('click', () => $(popover).popover('hide'));
}

export const getSpanText = ({ notifications }) => {
    return notifications.map((notification) => {
        let matches = Array.from(notification.matchAll(/@(rgb\( *\d+ *, *\d+ *, *\d+ *\))/g)) // match "@rgb(0,0,0)"
        
        let normalText =  matches.length ? notification.substring(0, matches[0].index) : notification;

        let spans =  matches.map((match, index) => {
            let nextMatch = matches[index + 1];
            let beginIndex = match[0].length + (match.index || 0) + 1; // +1 white space
            let endIndex = nextMatch ? (nextMatch.index || 0) : match.input?.length;

            return $('<span>')
                .append(match.input?.substring(beginIndex, endIndex)|| '')
                .attr({
                    'style': `color: ${match[1]};`
                })
        });

        return [normalText, ...spans]
    });
}

export default ActionAviso;