import FormManager from "../../FormManager";
import { saveLookupFields, fixLookupFields, recoverLookupFields } from "../../nLookUp";
import { nFraControl } from "../../nFraControl";

export function runEndPageScript(args) {
	if (FormManager.afterCreateAllForms.isStopped) ScriptCompanySelection.script(args);
	else FormManager.afterCreateAllForms.subscribe(() => ScriptCompanySelection.script(args));
}

class ScriptCompanySelection {
	static script({ scope, isMultiColumn}) {
		ScriptCompanySelection.handleParams(scope);
		ScriptCompanySelection.handleClickSubmit();

		initLookupStyle(isMultiColumn, true);
	}

	static handleFiltros({ Filtros, Class }) {
		if (Filtros) {
			FormManager.loadCadastro({ _ACadastro: Class, _AFiltros: Filtros });
		}
	}

	static handleParams({ Params }) {
		if (Params) {
			CarregarDataCadastro(Params);
		}
	}

	static handleClickSubmit() {
		$("#btnDefaultSubmit").on('click', function(event) {
			const form = $(event.target.form).data('q-form');
			const savedLookups = saveLookupFields(form);

			fixLookupFields(savedLookups);

			setTimeout(recoverLookupFields, 5, savedLookups);

			if (!nFraControl.ValidarCamposObrigatorios(form)) {
				event.preventDefault();
			}
			else {
				KTApp.blockPage();
			}
		});
	}
}