import FormManager from '../../FormManager';
import { fixLookupValueOnProcess } from '../../nLookUp';

export function runEndPageScript(args) {
	if (FormManager.afterCreateAllForms.isStopped) ScriptProcesso.script(args);
	else FormManager.afterCreateAllForms.subscribe(() => ScriptProcesso.script(args));
}

class ScriptProcesso {
	static script({ scope }) {
		ScriptProcesso.handleParams(scope);
		ScriptProcesso.handleFiltros(scope);

		$.applyDataMask();
		fixLookupValueOnProcess(true);

		ScriptProcesso.handleFieldFocus(scope);

		initLookupStyle(scope.DefinicaoObjetos.MultiColuna);	
	}

	static handleMsgLista({ Conteudo } = {}) {
		if (Conteudo.MsgLista) {
			$('#ConteudoMsgLista').DataTable(Conteudo.MsgLista.datatablesettings);
		}
	}

	static handleParams({ Params } = {}) {
		if (Params) {
			CarregarDataCadastro(Params);
		}		
	}
	
	static handleFiltros({ Filtros } = {}) {
		if (Filtros) {
			FormManager.FiltroModal = Filtros;
			FormManager.SetarValoresInputs(afiltro);
		}
	}

	static handleFieldFocus({ DefinicaoObjetos }) {
		const { WorkSpace, Detalhes } = DefinicaoObjetos;
 		
		if (WorkSpace) {
			const detail = Detalhes.find(({ Ativo }) => Ativo);

			if (!detail) return;

			const { Class, Alias } = detail.DefinicaoObjetos;
			const form = FormManager.byname(Class, Alias);

			form?.focusFirstField();
			form?.triggerExpressions();
		}
		else {
			FormManager.itens.firstUsable()?.focusFirstField();
			FormManager.itens.firstUsable()?.triggerExpressions();
		}
	}
}