import FormManager from '../../FormManager';

export function runEndPageScript(args) {
	if (FormManager.afterCreateAllForms.isStopped) ScriptRelatorio.script(args);
	else FormManager.afterCreateAllForms.subscribe(() => ScriptRelatorio.script(args));
}

class ScriptRelatorio {
	static script({ scope }) {
		ScriptRelatorio.handleParams(scope);
		ScriptRelatorio.handleConteudo(scope);

		$.applyDataMask();

		ScriptRelatorio.handleFieldFocus(scope);

		initLookupStyle(scope.DefinicaoObjetos.MultiColuna);
	}

	static handleParams({ Params } = {}) {
		if (Params) {
			CarregarDataCadastro(Params);
		}
	}

	static handleConteudo({ Conteudo } = {}) {
		if (Conteudo) {
			window.location.assign("#Conteudo");
			
			if (Conteudo.MsgLista) {
				$("#ConteudoMsgLista").DataTable(Conteudo.MsgLista.datatablesettings);
			}
		}
	}

	static handleFieldFocus({ DefinicaoObjetos }) {
		const { WorkSpace, Detalhes } = DefinicaoObjetos;
 		
		if (WorkSpace) {
			const detail = Detalhes.find(({ Ativo }) => Ativo);

			if (!detail) return;

			const { Class, Alias } = detail.DefinicaoObjetos;
			const form = FormManager.byname(Class, Alias);

			form?.focusFirstField();
			form?.triggerExpressions();
		}
		else {
			FormManager.itens.firstUsable()?.focusFirstField();
			FormManager.itens.firstUsable()?.triggerExpressions();
		}
	}
}