import Mustache from 'mustache';

export default class WidgetsBase {
  replaceTemplateWithVars(template, vars) {
    const varExpression = /{{[ | \n]*(\S+)[ | \n]*}}/g;
    // const replacer = (match, capturedGroup) => { console.log(vars, capturedGroup); return (vars || {})[capturedGroup]}

    const replacer = (match, capturedGroup) => {
      return capturedGroup.split('.').reduce((prev, cur) => {
        return prev[cur]
      }, vars)
    }

    return template.replace(varExpression, replacer)
  }

  /**
   * 
   * @param scope Data for use in template
   * @param template Html-mustache template
   * @param style (sc|sa|c)ss styles for use with mustache
   */
  render({ scope, template, style }) {
    // console.log("WidgetScope", scope)

    return Mustache.render(template, { ...scope, ...style });
	}
	
	/**
	 * 
	 * @param {jQuery} toReplace Element to be replaced
	 * @param {jQuery} replacer Element to be rendered
	 */
	replaceWith(toReplace, replacer) {
		if (!toReplace.exists()) return;

		replacer.css({ opacity: 0, transition: 'opacity 1.5s' })
		
		$(toReplace).replaceWith(replacer);
		
		setTimeout(() => { replacer.css({ opacity: 1 }) });
	}
}