import template from './twButtonControl.component.html';
import style from './twButtonControl.component.scss';
import WidgetBase from '../Widget.base';
import { ActionExecutarOperacaoDataSet } from '../../../nGrid';

export const buildWidget = args => new ButtonControl(args);

class ButtonControl extends WidgetBase {
	constructor(args) {
		super();

		this.buildWidget(args);
	}

	buildWidget({ element, scope, DefinicaoObjetos }) {
		this.setButtonType(scope);
		this.setButtonAlign(scope);

		let widgetElement = $(this.render({ template, scope, style }));

		this.setAction({ widgetElement, scope, DefinicaoObjetos });
		this.replaceWith($(element), widgetElement);

		return widgetElement;
	}

	setButtonType(scope) {
		const switchType = ({ TypeControl }) => {
			switch (TypeControl) {
				case 'Primary': return 'btn-dark';
				case 'Secondary': return 'btn-outline-dark';
				case 'Main': return 'btn-primary';
				default: return '';
			}
		}

		scope.typeClassName = switchType(scope);
	}

	setButtonAlign(scope) {
		let { Align } = scope;

		switch (Align) {
			case 'twaRight': return scope.twaRight = true;
		}
	}

	setAction({ widgetElement, DefinicaoObjetos , scope: { Action } }) {
		let onClick = getToolButtonAction({
			DefinicaoObjetos,
			toolButton: Action,
		});

		widgetElement
			.get(0)
			.addEventListener('click', onClick);
	}
}