import { evaluateGridConfig, prepareGridConfig, createGrid } from "../../../gridConfigurator";
import { createdxDatasource } from "../../../nGrid";

import * as CardViewTemplate from './Conciliacao/CardView.template.html';
import styleAgenciaBanco from './Conciliacao/CardView.template.scss';


export const buildWidget = (args) => CardView.buildWidget(args);

class CardView {
	static buildWidget({ scope }) {
		CardView.buildGrid(scope);
	}

	static buildGrid({Class, DefinicaoObjetos}) {
		const parseConfig = (gridConfig) => { try { return JSON.parse(gridConfig)} catch{ return {} } };

		let parsedConfig = parseConfig(DefinicaoObjetos.consulta); //trocar a .consulta pelo o qe vier no widget
		let configCardView = CardView.getConfigCardView({ Class, rowTemplateName: 'agenciaBanco'}) //parsedConfig.rowTemplate}); 
		
		console.log('configCardView', configCardView);
		evaluateGridConfig(parsedConfig);


		/* begin: devem ser mandadas no json */
		
			parsedConfig.showColumnHeaders = false;
			parsedConfig.showColumnLines = false;
			parsedConfig.filterRow = false;
			parsedConfig.pager = { visible: false };
			parsedConfig.showBorders = false;

		/* end: devem ser mandadas no json */


		let config = prepareGridConfig(configCardView, parsedConfig);

		config.columns = [];

		// config.rowTemplate = CardView.RowTemplateRef;

		createGrid('dataGrid', config); // trocar o id pelo id da grid no  widget
	}

	static getConfigCardView({ Class, rowTemplateName }) {
		const invalidTemplateName = () => console.error('Invalid template name');
		const switchConfig = (templateName, Class) => (CardView[templateName] || invalidTemplateName)({ Class });

		return switchConfig(rowTemplateName, Class);
	}

	static agenciaBanco({ Class }) {
		styleAgenciaBanco.use();

		return {
			dataSource: createdxDatasource({ _AClassName: Class }),
			onToolbarPreparing: (e) => { e.toolbarOptions.visible = false } ,
			rowTemplate: CardView.RowTemplateRef
		}
	}


	static RowTemplateRef(el, options, ...args) {
		const replaceTemplateWithVars = (template, vars) => {
			const varExpression = /{{[ | \n]*(\S+)[ | \n]*}}/g;
			// const replacer = (match, capturedGroup) => { console.log(vars, capturedGroup); return (vars || {})[capturedGroup]}
			
			const replacer = (match, capturedGroup) => { 
				return capturedGroup.split('.').reduce((prev, cur) => {
					return prev[cur]
				}, vars)
			}
	
			return template.replace(varExpression, replacer)
		}

		let test = {
			topLeft: {
				agency: {
					text: "Agência",
					value: "2086"
				},
				account: {
					text: "Conta",
					value: "0557182-01"
				}
			},
			topRight: {
				value: "R$ 10.247,93"
			},
			bottomLeft: {
				text: "Sem concilições Pendentes"
			},
			bottomRight: {
				text: "Lançamentos sem Contrapartida"
			}
		}
	
		let row = replaceTemplateWithVars(CardViewTemplate, test)
		
		el.append(row)
	}
}