/**
 * @param str String base for contruct the acronym
 * @param separator Array of characters to be used as separators
 * @param length Maximum size of the resulting string
 */
export function Acronym({ str = '', separator = [], length = 0 }) {
  const charsToRegexp = (separator) => new RegExp(`[${separator.join('')}]+`);
  const joinFirstLetter = (acc, element) => (acc + (element[0] || ''));  
	const swap = (arr, i, j) => [arr[i], arr[j]] = [arr[j], arr[i]];

	if (separator.indexOf('-') > -1) swap(separator, separator.indexOf('-'), separator.length); // Non escaping '-', moving to the end

  return str
    .split(charsToRegexp(separator))
    .reduce(joinFirstLetter, '')
    .slice(0, length || str.length);
}