export class DynamicImport {
	static async Import(Module, namedImport) {
		try {
			let t = await import(/* webpackChunkName: "[request]" */ `../DynamicImports/${Module}`);
			
			return namedImport ? t[namedImport] : t;
		}
		catch (e) {
			throw e;
		}
	}

	/**
	 * 
	 * @param {function|object} fn function or an async function that returns a function
	 * @param  {...any} args arguments to be called by fn
	 * 
	 * Get a function under DynamicImport and executes it
	 */
	static async execute(fn, ...args) {
		try {
			if (typeof fn == 'object') {
				fn = await fn //in case fn goes through fetch
			}
			return fn(...args);
		}
		catch (e) {
			throw e;
		}
	}
}