﻿export const qApp = (() => {

    const configureLocales = () => {
        moment.locale("pt-br");
    };

    const handleMenu = () => {
        const $searchInput = $("#main-menu-search");

        const showOpenMenuItem = item => {
            $(item).addClass("menu-item-open").removeClass("d-none");
        };

        const resetMenuSelected = () => {
            $("li.menu-item.searchable.selected").addClass("menu-item-open").removeClass("d-none");
        };

        const resetMenuVisible = visible => {
          $("li.menu-item.searchable").removeClass("menu-item-open");
          $("li.menu-item.menu-submenu.searchable").addClass("d-none");

          (visible) ? $("li.menu-item.searchable").removeClass("menu-item-open").removeClass("d-none") : $("li.menu-item.searchable").removeClass("menu-item-open").addClass("d-none");

          $("li.menu-item.searchable.menu-item[data-menu-search-only]").removeClass("menu-item-open").addClass("d-none");
        };

        const searchInputMenuClosest = (key, value) => {
            showOpenMenuItem(value);
            $(value).closest("ul").closest("li.menu-item.searchable").each(searchInputMenuClosest);
        };

        const performSearch = () => {
            const str = $searchInput.val();

            if (!str) {
                resetMenuVisible(true);
                resetMenuSelected();
                return;
            }

            resetMenuVisible(false);

            let menus = [];
            const isDebug = typeof $ModoDebug == 'boolean';
            
            if (isDebug) menus = $(`li.menu-item.searchable[data-menu-descricao*="${str}" i], .menu-item.searchable[data-menu-class*="${str}" i]`);
            else menus = $(`li.menu-item.searchable[data-menu-descricao*="${str}" i]`);
            
            menus.each((key, value) => {
                $(value).show();
                $(value).removeClass("d-none").removeClass("menu-item-open");
                $(value).find("li.menu-item.searchable").removeClass("d-none");
                $(value).closest("ul").closest("li.menu-item.searchable").each(searchInputMenuClosest); 
            });
        };

        const delay = (fn, ms) => {
            let timer = 0;
            return function(...args) {
              clearTimeout(timer)
              timer = setTimeout(fn.bind(this, ...args), ms || 0)
            }
        }

        $searchInput.on("keyup", delay(performSearch, 300));

        $("#main-menu-open").on("click",
            () => {
                setTimeout(() => {
                        $searchInput.focus();
                    },
                    100);
            });
    };

  return {
    init() {
      configureLocales();
      handleMenu();
    },
    handleMenuSearch() {
      handleMenu();
    }
  };

})();