export class condExpressionValidator{
	constructor(expression, getField, elementRef) {
		this.getFieldValue = getField;
		this.expression = expression;
		this.elementRef = elementRef;
	}

	include() {
		let [field, values] = this.parseParams(arguments[0]);
		let fieldValue = this.getFieldValue(this.elementRef, field);

		return values.includes(fieldValue);
	}

	greater() {
		let [field, values] = this.parseParams(arguments[0]);
		let fieldValue = this.getFieldValue(this.elementRef, field);

		return fieldValue > values[0];
	}

	greaterEqual() {
		let [field, values] = this.parseParams(arguments[0]);
		let fieldValue = this.getFieldValue(this.elementRef, field);

		return fieldValue <= values[0];
	}

	less() {
		let [field, values] = this.parseParams(arguments[0]);
		let fieldValue = this.getFieldValue(this.elementRef, field);

		return fieldValue < values[0];
	}

	lessEqual() {
		let [field, values] = this.parseParams(arguments[0]);
		let fieldValue = this.getFieldValue(this.elementRef, field);

		return fieldValue <= values[0];
	}

	parseParams(args) {
		return [args[0], args.slice(1)];
	}

	If(args) {
		let [condition, ifValue, elseValue] = [...arguments[0]];
		return condition ? ifValue : elseValue;
	}

	Or(args) {
		let [a, b] = [...arguments[0]];

		return Boolean(a) || Boolean(b);
	}

	And(args) {
		let [a, b] = [...arguments[0]];

		return Boolean(a) && Boolean(b);
	}

	Between(args) {
		let [field, a, b] = [...arguments[0]];
		let fieldValue = this.getFieldValue(field);

		return fieldValue >= a && fieldValue <= b;
	}

	execute() {
		const condAND		 = (...args) => this.And(args);
		const condBETWEEN	 = (...args) => this.Between(args);
		const condIN		 = (...args) => this.include(args);
		const condIGUAL		 = (...args) => this.include(args);
		const condIF		 = (...args) => this.If(args); 
		const condMAIOR		 = (...args) => this.greater(args);
		const condMAIORIGUAL = (...args) => this.greaterEqual(args);
		const condMENOR		 = (...args) => this.less(args);
		const condMENORIGUAL = (...args) => this.lessEqual(args);
		const condOR				 = (...args) => this.Or(args);
		try {
			return eval(this.expression);
		}
		catch (e) {
			console.log(e);
			return false;
		}
	}
}