import { qGrid } from "./grid";
import { Subject } from 'rxjs';

export default function gridDefaultOptions() {
  return {
    "columnFixing": { enabled: true },
    "columnAutoWidth": true,
    "onCellPrepared": qGrid.onCellPrepared,
    "onContentReady": qGrid.onContentReady,
    "showBorders": true,
    "showRowLines": true,
    "cacheEnabled": false,
    "scrolling": {
      columnRenderingMode: "virtual"
    },
    "allowColumnReordering": false,
    "onStateReady": new Subject(),
    "headerFilter": {
      allowSearch: true
    },
    export: {
      customizeExcelCell: (e) => {
        if (typeof e.value === 'string') {
          e.value = e.value.replace(/&nbsp/g, ' ');
        }
      }
    }
  }
}