import { DialogsSemResposta, FormatErrorMessage, ProcessarDialogsRetorno } from "../../nDialog";
import { Timer } from "../../Timer";

export const ActExecuteProcesso = async ({ _AClass, _AParams }) => {
    const timer = new Timer();

    timer.IniciarExecucao();

    try {
        const response = await  axios.post('nHttpServicos/ActionExecuteProcesso', {
            _AClass,
            _AParams,
        });

        const { data } = response;
        const { Result } = data;

        if (Result.dialogs && DialogsSemResposta(Result.dialogs)) {
            ProcessarDialogsRetorno({ data: { ...Result } }, () => {
                KTApp.unblockPage();
            });
        }
        else {
            FormatErrorMessage(Result.Mensagem || 'Erro ao executar ação');
        }
    }
    catch (e) {
        FormatErrorMessage('Erro ao executar ação');

        console.error(e);
    }

    timer.FinalizarExecucao();
}