import { nFraControl } from "./nFraControl";

export class FraControlHistCt {
	constructor(field) {
		this._field = field;
		this._ctrlCODIGOHISTCTB = field.componente;
		this._oldCHAVELCTOCTB = null;
		this._oldCodigoHist = null;
		this._complContainer = $('#divComplHist', field.InstanciaFormulario.element);
	}

	async CarregarDefinicaoHistorico(Event, options = {}) {
		let AFocar = false;
		if (Event != null) {
			AFocar = Event.currentTarget.id == 'ctrlCODIGOHISTCTB';
		}
		
		let _CHAVELCTOCTB = this._field.InstanciaFormulario.getvalue('CHAVELCTOCTB') || '';
		if (_CHAVELCTOCTB != '' && this._oldCHAVELCTOCTB != _CHAVELCTOCTB) {
			this._oldCodigoHist = null;
		}
		this._oldCHAVELCTOCTB = _CHAVELCTOCTB;
	
		if (this._ctrlCODIGOHISTCTB.exists()) {
			let CodigoHistorico = this._field.getvalue() || '';
			let ClassName = this._ctrlCODIGOHISTCTB.data('classname');

			if (CodigoHistorico != '' && this._oldCodigoHist != CodigoHistorico) {
				let Scope = { CodigoHistorico, ClassName};
				this._oldCodigoHist = CodigoHistorico;

				let response = await $.ajax({
					type: 'GET',
					url: 'HistoricoCtb?Scope=' + JSON.stringify(Scope),
				});

				this._carregarDadosHistorico({
					focus: AFocar,
					htmlContainerText: response,
					...options
				});
			} 
			else if (Event && Event.currentTarget.id == 'ctrlCODIGOHISTCTB') {
				if (CodigoHistorico == '') {
					this._oldCodigoHist = CodigoHistorico;
					this._complContainer.html("");
				}
				if (options.fromKeyPress) {
						nFraControl.nextFocus(Event.currentTarget, Event.shiftKey ? -1 : 1);
				}
			}
		}
	}

	async _carregarDadosHistorico({ focus, htmlContainerText, fromKeyPress }) {
		await this._complContainer.html(htmlContainerText).promise();
		
		var complementos = $('.complhistoricoctb');

		this._inputsCompl = this._complContainer.find('.cad-control')

		for (let i = 0; i < complementos.length; i++) {
			let complemento = complementos[i];

			if($(complemento).val() != null) {
				let AValores = $(complemento).val().split('|');

				for (let j = 0; j < this._inputsCompl.length; j++) {
					let input = this._inputsCompl.eq(j);
					
					input.on('keypress', FraControlKeyPress);
					input.val(AValores[j]);

					this._setOnBlurComplemento(input);
				}

				if (fromKeyPress) {
					if (focus && this._podeFocarNoComplementoHistorico()) {
						$("#ctrlComplHist0").focus();
					} 
					else {
						nFraControl.nextFocus(this._ctrlCODIGOHISTCTB);
					}
				}
			}
		}
	}

	_podeFocarNoComplementoHistorico() {
		return $("#ctrlComplHist0").length > 0 && this._ctrlCODIGOHISTCTB.closest('form').data('class').toLowerCase() === $("#ctrlComplHist0").closest('form').data('class').toLowerCase();
	}

	_setOnBlurComplemento(jQElement) {
		let { ntcEdit } = jQElement.data();

		if (ntcEdit) {
			$(jQElement).on('blur', () => this._updateInputComplemento());
		}
	}
	
	_updateInputComplemento() {
		let AValor = '';
		
		for (let input of this._inputsCompl) {
			AValor = AValor == '' ? $(input).val() : AValor + '|' + $(input).val();
		}
		
		if (AValor != '') {
			$('.complhistoricoctb').val(AValor);
		}
	}
}