import { qGrid } from "../grid";
import dxDataGrid from 'devextreme/ui/data_grid';

export class GridConfigModal {
	static config({ DataSource, Class, GridName }) {
		const rowDoubleClick = function () {
			$("#myModal").modal('hide');
			RetornarData();
		}
		
		const stateStoring = {
			enabled: true,
			type: "custom",
			customLoad: function () { return qGrid.loadGridState(Class + GridName); },
			customSave: function (state) { qGrid.saveGridState(Class + GridName, state); }
		}
		
		const onToolbarPreparing = function (e) {
			var toolbarItems = e.toolbarOptions.items;
		
			toolbarItems.push({
				widget: "dxButton",
				locateInMenu: "auto",
				showText: "inMenu",
				options: {
					icon: "refresh",
					text: "Atualizar",
					hint: "Atualizar",
					onClick: function () { dxDataGrid.getInstance("#dataGridModal").refresh(); }
				},
				location: "after"
			});

			toolbarItems.push({
				location: "after",
				widget: "dxDropDownButton",
				options: {
					dropDownOptions: {
						width: 140
					},
					displayExpr: "text",
					icon: "las la-th",
					hint: "Opções do grid",
					items: [
						{ text: "Restaurar colunas", action: "restaurar"},
						{ text: "Selecionar colunas", action: "selecionar"}
					],
					onItemClick(data) {
						if (data.itemData.action == 'restaurar'){
							dxDataGrid.getInstance('#dataGridModal').state({});
						} else {
							dxDataGrid.getInstance("#dataGridModal").showColumnChooser();
						}
					}
				}
			});
		}

		return {
			onRowDblClick: rowDoubleClick,
			onRowRemoving: ConsultaAjaxDeleteReg,
			dataSource: DataSource,
			showRowLines: false,
			stateStoring: stateStoring,
			onToolbarPreparing: onToolbarPreparing
		}
	}
}