import dxDataGrid from 'devextreme/ui/data_grid';
import dxButton from 'devextreme/ui/button';
import dxDropDownButton from 'devextreme/ui/drop_down_button';
import ptMessages from 'devextreme/localization/messages/pt.json';
import { locale, loadMessages } from 'devextreme/localization';
import { createGrid, createGridBase64, evaluateGridConfig, prepareGridConfig } from './gridConfigurator';
import { qGrid } from './grid';
import { nExpressionExecutor } from './nExpressionExecutor';
import { registerPrototypes } from './registerPrototypes';
import Initializer from './initializer';
import FormManager from './FormManager';
import { carregarDadosDoCEP, PrepararMaskDefault } from './nEndereco';
import { carregarDadosRFB } from './nWebService';
import { exporter, loadBase64File, showThumbnail, downloadFileFromData, aplicarCriptografia } from './nArquivos';
import { initLookupStyle, fixLookupFields, recoverLookupFields, saveLookupFields, FindLookupValue } from './nLookUp';
import {
    	cxGridIncluirFiltroMaster, fixGridLayout, AddColumnButtonsCadastro, AddColumnButtonsEdicao,
		AbrirCadastroModal, loadData, dxdatagridDateFilterRevert, dxdatagridDateFilter, GetColorFromValoresCores,
		createdxDatasource,
		rowDataValues,
		ActionExecutarOperacaoDataSet,		
		GridActionHelper,
		fixRowValues
} from './nGrid';
import { ShowDialogs, ProcessarDialogsRetorno, DialogsSemResposta, criarDialogSimNao, criarDialogOk, FormatErrorMessage, VerificaConfirmacaoAction} from './nDialog';
import { createAccordion, addAccordionClassField } from './nExpandables';
import WizardManager from './WizardManager';
import { nFraControl } from './nFraControl';
import { createContextMenu } from './ContextMenu';
import { resizeIframe } from './nIframeUtils';
import { ControleBaseIsentaOutras } from './nControleBaseIsentaOutras';
import { CarregarMenu } from './nMenu';
import { FormState } from './nCadastro';
import SessionManager from './SessionManager';
import CookiesManager from './CookiesManager';
import { RequestDadosCadastro, PostWithForm } from './nRequests';
import { TnCaptcha } from './nCaptcha';
import { CarregarTreeList, CarregarCheckTreeView } from './treeview/treeview';

import 'devextreme/dist/css/dx.common.css';
import 'devextreme/dist/css/dx.light.compact.css';
import { CustomStoreArray } from './grid/CustomStoreArray';
import { configureDatepicker, setDatePicker } from './setDatepicker';
import { createFormRepeater } from '../ts/components/form-repeater/create-form-repeater';
import { createNtcGrid } from '../ts/components/fra-control/ntc-grid/create-ntc-grid';
import { createNtcLinkAnnotation } from '../ts/components/fra-control/ntc-link-annotation/create-ntc-link-annotation';
import { Layout } from '../ts/components/widgets/layout/layout';
import { getToolButtonAction, executeActionFromPartial } from '../ts/components/toolbuttons/toolbutton-action/toolbutton-action';
import { CreateWidget } from '../ts/components/widgets/create-widget';
import { createDropdownButton } from '../ts/components/toolbuttons/dropdown-button/create-dropdown-button';
import { take, first } from 'rxjs/operators';
import { createFooterToolbuttons } from '../ts/components/toolbuttons/toobuttons';
import { RelatorioExibir } from '../ts/pages/relatorio-exibir/relatorio-exibir';
import { openPdf } from '../ts/pages/relatorio-exibir/open-pdf';
import { ConfigureEnvioZen } from '../ts/pages/envio-zen/envio-zen';
import { createOnFooterToolbutton, createOnToolBar } from '../ts/components/toolbuttons/split-report-param/split-report-param';
import gridManager from '../ts/components/grid-manager/grid-manager';
import { createNtcMemoAnnotation } from '../ts/components/fra-control/ntc-memo-annotation/create-ntc-memo-annotation';
import { ControlType } from './nFormulario';
import { createWizardNavigationToolbar } from '../ts/components/wizard-navigation/wizard-navigation';
import { LoadCadPageDynamicTab, scrollToElement } from '../ts/components/cad-page/cad-page-dynamic-tab';
import widgetManager from '../ts/components/widgets/widget-manager';

//EXCLUIR NO FINAL DA REFATORAÇÃO - IMPORTS RELACIONADOS TAMBÉM
window.ShowDialogs = ShowDialogs;
window.DialogsSemResposta = DialogsSemResposta;

/**
 * Expose functions to global escope
 */

window.first = first;
window.take = take;
window.createGrid = createGrid;
window.createGridBase64 = createGridBase64;
window.dxButton = dxButton;
window.dxDropDownButton = dxDropDownButton;
window.dxDataGrid = dxDataGrid;
window.evaluateGridConfig = evaluateGridConfig;
window.FormManager = FormManager;
window.nExpressionExecutor = nExpressionExecutor;
window.prepareGridConfig = prepareGridConfig;
window.qGrid = qGrid;
window.carregarDadosDoCEP = carregarDadosDoCEP;
window.carregarDadosRFB = carregarDadosRFB;
window.PrepararMaskDefault = PrepararMaskDefault;
window.exporter = exporter;
window.loadBase64File = loadBase64File;
window.showThumbnail = showThumbnail;
window.initLookupStyle = initLookupStyle;
window.fixLookupFields = fixLookupFields;
window.recoverLookupFields = recoverLookupFields;
window.saveLookupFields = saveLookupFields;
window.FindLookupValue = FindLookupValue;
window.downloadFileFromData = downloadFileFromData;
window.cxGridIncluirFiltroMaster = cxGridIncluirFiltroMaster;
window.fixGridLayout = fixGridLayout;
window.AddColumnButtonsCadastro = AddColumnButtonsCadastro;
window.AbrirCadastroModal = AbrirCadastroModal;
window.loadData = loadData;
window.dxdatagridDateFilterRevert = dxdatagridDateFilterRevert;
window.dxdatagridDateFilter = dxdatagridDateFilter;
window.ProcessarDialogsRetorno = ProcessarDialogsRetorno;
window.criarDialogSimNao = criarDialogSimNao;
window.criarDialogOk = criarDialogOk;
window.FormatErrorMessage = FormatErrorMessage;
window.createAccordion = createAccordion;
window.addAccordionClassField = addAccordionClassField;
window.WizardManager = WizardManager;
window.nextFocus = nFraControl.nextFocus;
window.FraControlKeyPress = nFraControl.FraControlKeyPress;
window.FraControlChange = nFraControl.FraControlChange;
window.createContextMenu = createContextMenu;
window.GetColorFromValoresCores = GetColorFromValoresCores;
window.rowDataValues = rowDataValues;
window.resizeIframe = resizeIframe;
window.createdxDatasource = createdxDatasource;
window.ControleBaseIsentaOutras = ControleBaseIsentaOutras;
window.CarregarMenu = CarregarMenu;
window.focusImputFunc = nFraControl.focusInputFunc;
window.FormState = FormState;
window.SessionManager = SessionManager;
window.CookiesManager = CookiesManager;
window.RequestDadosCadastro = RequestDadosCadastro;
window.PostWithForm = PostWithForm;
window.TnCaptcha = TnCaptcha;
window.ActionExecutarOperacaoDataSet = ActionExecutarOperacaoDataSet;
window.VerificaConfirmacaoAction = VerificaConfirmacaoAction;
window.CarregarTreeList = CarregarTreeList;
window.CarregarCheckTreeView = CarregarCheckTreeView;
window.aplicarCriptografia = aplicarCriptografia;
window.CustomStoreArray = CustomStoreArray;
window.setDatePicker = setDatePicker;
window.createFormRepeater = createFormRepeater;
window.createNtcGrid = createNtcGrid;
window.createNtcLinkAnnotation = createNtcLinkAnnotation;
window.Layout = Layout;
window.executeActionFromPartial = executeActionFromPartial;
window.CreateWidget = CreateWidget;
window.configureDatepicker = configureDatepicker;
window.createDropdownButton = createDropdownButton;
window.createFooterToolbuttons = createFooterToolbuttons;
window.RelatorioExibir = RelatorioExibir;
window.openPdf = openPdf;
window.ConfigureEnvioZen = ConfigureEnvioZen;
window.createOnFooterToolbutton = createOnFooterToolbutton;
window.createOnToolBar = createOnToolBar;
window.gridManager = gridManager;
window.getToolButtonAction = getToolButtonAction;
window.createNtcMemoAnnotation = createNtcMemoAnnotation;
window.ControlType = ControlType;
window.createWizardNavigationToolbar = createWizardNavigationToolbar;
window.GridActionHelper = GridActionHelper;
window.LoadCadPageDynamicTab = LoadCadPageDynamicTab;
window.fixRowValues = fixRowValues;
window.scrollToElement = scrollToElement;
window.widgetManager = widgetManager;

locale('pt-Br');
loadMessages(ptMessages);
registerPrototypes();
Initializer.init();

qGrid.init();