var $ControlesBase = []; //Guarda as referencias pois nos eventos de focus não sabe qual o objeto

export class ControleBaseIsentaOutras {
	constructor(cadastro, campobase, campoaisentas, campooutras, campototal, campoaliquota, campovalor) {
		this.cadastro = cadastro;
		this.campobase = campobase;
		this.campoisentas = campoaisentas;
		this.campooutras = campooutras;
		this.campototal = campototal;
		this.campoaliquota = campoaliquota;
		this.campovalor = campovalor;
		this.index = $ControlesBase.length + 1;
		$ControlesBase[this.index - 1] = this;

		this.cadastro.getcomponent(this.campobase)[0].setAttribute('data-ControleBase', this.index);
		this.cadastro.getcomponent(this.campoisentas)[0].setAttribute('data-ControleBase', this.index);
		this.cadastro.getcomponent(this.campooutras)[0].setAttribute('data-ControleBase', this.index);
		this.cadastro.getcomponent(this.campoaliquota)[0].setAttribute('data-ControleBase', this.index);
		this.cadastro.getcomponent(this.campovalor)[0].setAttribute('data-ControleBase', this.index);

		this.cadastro.getcomponent(this.campobase).focus(this.SetValorTotalBase);
		this.cadastro.getcomponent(this.campoisentas).focus(this.SetRestoValorTotalIsentas);
		this.cadastro.getcomponent(this.campooutras).focus(this.SetRestoValorTotalOutras);
		this.cadastro.getcomponent(this.campoaliquota).focus(this.CalcularValores);
		this.cadastro.getcomponent(this.campovalor).focus(this.CalcularValores);
	}

	CalcularValores() {
		var controle = $ControlesBase[this.getAttribute('data-ControleBase') - 1];
		if ((controle.cadastro.getvalue(controle.campobase) != '') && (controle.cadastro.getvalue(controle.campoaliquota) != '')) {
			var base = controle.cadastro.getvalueasnumeric(controle.campobase);
			var aliquota = controle.cadastro.getvalueasnumeric(controle.campoaliquota);
			var valor = ((base * aliquota) / 100).toFixed(2);
			controle.cadastro.setvalue(controle.campovalor, valor);
		}
	}

	SetValorTotalBase(sender) {
		var controle = $ControlesBase[this.getAttribute('data-ControleBase') - 1];
		if (controle.cadastro.getvalue(controle.campobase) == '') {
			controle.cadastro.setvalue(controle.campobase, controle.cadastro.getvalue(controle.campototal));
		}
	}

	SetRestoValorTotalIsentas(sender) {
		var controle = $ControlesBase[this.getAttribute('data-ControleBase') - 1];
		var diferenca = controle.PegarDiferenca();
		if (controle.cadastro.getvalue(controle.campoisentas) == '') {
			controle.cadastro.setvalue(controle.campoisentas, diferenca);
		}
	}

	SetRestoValorTotalOutras(sender) {
		var controle = $ControlesBase[this.getAttribute('data-ControleBase') - 1];
		var diferenca = controle.PegarDiferenca();
		if (controle.cadastro.getvalue(controle.campooutras) == '') {
			controle.cadastro.setvalue(controle.campooutras, diferenca);
		}
	}

	PegarDiferenca(sender) {
		var base = this.cadastro.getvalueasnumeric(this.campobase);
		var isentas = this.cadastro.getvalueasnumeric(this.campoisentas);
		var outras = this.cadastro.getvalueasnumeric(this.campooutras);
		var lancado = parseFloat(base) + parseFloat(isentas) + parseFloat(outras);
		var total = this.cadastro.getvalueasnumeric(this.campototal);
		return String((total - lancado).toFixed(2));
	}
}