const nDialogTypes = {
	WARNING: "nmtWarning",
	ERROR: "nmtError",
	INFORMATION: "nmtInformation",
	CONFIRMATION: "nmtConfirmation",
	CUSTOM: "nmtCustom",
	CONCLUSION: "nmtConclusion"
};

export const criarDialogOk = function (_Amessage, _Atitle, callbackOk, escape) {
    let canEscape = (escape == undefined) ? true : escape;
    bootbox.alert({
        message: _Amessage,
        title: _Atitle,
        onEscape: canEscape,
        callback: callbackOk
    });
}

export const criarDialogSimNao = function (_Amessage, _Atitle, callbackSim, callbackNao) {
    let buttons = [
        {
            label: 'Sim',
            className: "btn-success",
            callback: callbackSim
        },
        {
            label: 'Não',
            className: "btn-danger",
            callback: callbackNao
        }
    ];
    criarDialog(_Amessage, _Atitle, buttons);
}

function criarDialog(_Amessage, _Atitle, _Abuttons) {
    bootbox.dialog({
        message: _Amessage,
        title: _Atitle,
        buttons: _Abuttons
    });
}

export const DialogsSemResposta = function (dialogs) {
    var ASemResposta = false;
    for (var i = 0; i < dialogs.length; i++) {
        if (dialogs[i].Resposta == '') {
            ASemResposta = true;
        }
    }
    return ASemResposta;
}

export const ProcessarDialogsRetorno = function (_ARetorno, _AOnRequest, _ASuccessFunction, _AAdditionalParams) {
    for (var i = 0; i < _ARetorno.data.dialogs.length; i++) {
        if (_ARetorno.data.dialogs[i].Resposta == '') {
            let Adialog = _ARetorno.data.dialogs[i];
            KTApp.unblockPage();
            if (Adialog.Tipo === nDialogTypes.CONCLUSION) {
                qNotifier.success(Adialog.Mensagem);
                if (typeof _ASuccessFunction === 'function') {
                    _ASuccessFunction(_ARetorno, _AAdditionalParams);
                }
            } else {
                let $Index = i;
                let Scope = _ARetorno.data;
                let Abuttons = {};
                var sname = "btn-outline-dark";
                for (var j = 0; j < Adialog.Options.length; j++) {
                    let opt = {
                        label: Adialog.Options[j],
                        className: sname,
                        callback: function (a) {
                            Scope.dialogs[$Index].Resposta = $(a.target).data('bb-handler').toString();
                            if (Scope.dialogs[$Index].Tipo !== nDialogTypes.WARNING) {
                                KTApp.blockPage();
                                _AOnRequest(Scope);
                            }
                        }
                    }
                    Abuttons[j] = opt;
                }
                bootbox.dialog({
                    message: Adialog.Mensagem,
                    title: Adialog.Titulo,
                    buttons: Abuttons
                });
            }
        }
    }
}

export const ShowDialogs = function (dialogs) {
    for (var i = 0; i < dialogs.length; i++) {
        if (dialogs[i].Resposta == '') {
            let Adialog = dialogs[i];
            KTApp.unblockPage();
            let Abuttons = {};
            for (var j = 0; j < Adialog.Options.length; j++) {
                let opt = {
                    label: Adialog.Options[j],
                    className: "btn-primary",
                }
                Abuttons[j] = opt;
            }
            bootbox.dialog({
                message: Adialog.Mensagem,
                title: Adialog.Titulo,
                buttons: Abuttons
            });
        }
    }
}

export const FormatErrorMessage = function (_AText) {
    var n = _AText.indexOf('Você não esta logado');
    if (n != -1) {
        window.location = "/home/inicio";
    } else {
        qNotifier.error(_AText);
    }
}

export const VerificaConfirmacaoAction = function (confirmacao, onConfirm, actionName){
	if (confirmacao){
		const onCancel = function(){
            if (actionName) verifyRunCancelHandler(actionName);
         };

		criarDialogSimNao(confirmacao.Mensagem, "Confirma execução", onConfirm, onCancel);		
	}
	else{
	  onConfirm();
	}
}

const verifyRunCancelHandler = (actionName) => {
    const action = window[`${actionName}CancelHandler`];

    if (typeof action === 'function') action();
}