import { qApp } from "./app";
import SessionManager from "./SessionManager";

export function CarregarMenu(_APai) {
	try {
		axios
			.get('Menu')
			.then(({ data }) => {
				initMenu(_APai, data);
			})
	}
	catch (e) {
		console.error(e)
	}
}

function initMenu(_APai, htmlForMenu) {
	let menuHtmlString = '';
	let menuEl = $(htmlForMenu);
	let menuConfigEl = $('[data-create-menu-section="true"]', menuEl);

	let menuConfig = menuConfigEl.data('menu');

	menuConfigEl.replaceWith(renderMenu(menuConfig));

	menuHtmlString = menuEl.toArray().map(div => div.outerHTML).join('');

	sessionStorage.removeItem('menu' + SessionManager.moduloAtual);
	sessionStorage.setItem('menu' + SessionManager.moduloAtual, menuHtmlString);

	AppendMenu(_APai);
}

function renderMenu(menus) {
	let menusHtml = menus.map((menu) => {
		return `<li ${isVisible(menu) ? '' : 'style="display: none" data-menu-search-only'} class="menu-item menu-item-submenu searchable" aria-haspopup="true" 	
				data-menu-descricao="${menu.Text}" data-ktmenu-submenu-toggle="click" data-ktmenu-submenu-mode="accordion" data-ktmenu-link-redirect="1">
				<a href="#none" class="menu-link menu-toggle">
						<span></span>
					</i>
					<span class="menu-text app-module-menu">${menu.Text}</span>
					<i class="menu-arrow"></i>
				</a>
				${menu.Childs ? `
					<div class="menu-submenu">
						<span class="menu-text app-module-menu"></span>
						<ul class="menu-subnav">
							${renderSubmenu(menu)}
						</ul>
					</div>`: ''
			}
			</li>`;
	}).join('');

	return menusHtml;
}

function isVisible(item) {
	if (item.ClassAreaTrabalho) return false;
	if (item.Name && !item.Childs) return true;

	return item.Childs.reduce((visible, child) => {
		return visible || isVisible(child)
	}, false)
}

function renderSubmenu(item) {
	return item.Childs.map(item => `${item.Name ? pageLink(item) : subMenu(item)}`).join('');
}

function pageLink(item) {
	let href = ({ Name, ClassAreaTrabalho, ClassWizard, Tipo }) => (ClassAreaTrabalho ? `Processo?Scope={Class:&quot;${ClassAreaTrabalho}&quot;, Detalhe:&quot;${ClassWizard ? `${ClassWizard}_` : ''}${Name}&quot;}` : `${Tipo}?Scope={Class:&quot;${Name}&quot;}`);

	return `<li ${isVisible(item) ? 'class="menu-item searchable"' : 'class="menu-item searchable d-none" data-menu-search-only'} data-menu-descricao="${item.Text}" data-menu-class="${item.Name}" aria-haspopup="true" data-ktmenu-link-redirect="1">
			<a data-block-page-on-click href="${href(item)}" class="menu-link">
				<span class="menu-text">${item.Text}</span>
			</a>
		</li>`
}

function subMenu(item) {
	return `<li ${isVisible(item) ? 'class="menu-item searchable"' : 'class="menu-item searchable d-none" data-menu-search-only'} data-menu-descricao="${item.Text}"  aria-haspopup="true" data-ktmenu-submenu-toggle="click" data-ktmenu-submenu-mode="accordion">
		<a href="#none" class="menu-link menu-toggle">
			<span class="menu-text app-module-menu">${item.Text}</span>
			<i class="menu-arrow"></i>
		</a>
		<div class="menu-submenu">
			<span class="menu-text app-module-menu"></span>
			<ul class="menu-subnav">
				${renderSubmenu(item)}
			</ul>
		</div>
	</li>`
}


function AppendMenu(_APai) {
	var elPai = $('#' + _APai);
	let itenspesquisa = [];
	let i = 0;
	var section = "";
	elPai.html('').append(sessionStorage.getItem('menu' + SessionManager.moduloAtual));

	$('#menu-overlay a').each(function (index) {
		var description = this.text.trim();
		if ($(this).attr('href') != '#' && $(this).attr('href') != '#none') {
			itenspesquisa[i] = {
				label: description,
				value: description,
				link: $(this).attr('href'),
				section: section
			};
			i = i + 1;
		} else {
			if (section != description)
				section = description;
		}
	});
	sessionStorage.itenspesquisamenu = JSON.stringify(itenspesquisa);

	qApp.handleMenuSearch();
}