import moment from "moment";

export class nStringToDate{
  constructor(){
    this.dateRegExpInv = /^[0-9]{2}\-[0-9]{2}\-[0-9]{4}?$/;
    this.dateRegExpDelphi = /^[0-9]{2}\/[0-9]{2}\/[0-9]{4}?$/;
    this.dateTimeRegExp = /^[0-9]{4}\-[0-9]{2}\-[0-9]{2} [0-9]{2}\:[0-9]{2}\:[0-9]{2}?$/;          
    this.dateRegExp = /^[0-9]{4}\-[0-9]{2}\-[0-9]{2}?$/;                
    this.dateTimeRegExpBarra = /^[0-9]{4}\/[0-9]{2}\/[0-9]{2} [0-9]{2}\:[0-9]{2}\:[0-9]{2}?$/;
  }

  isDate(value){
     return this.dateRegExp.test(value)||
            this.dateRegExpDelphi.test(value)||
            this.dateTimeRegExp.test(value)||
            this.dateTimeRegExpBarra.test(value)||
            this.dateRegExpInv.test(value); 
  }

  toDate(value){
    if (this.dateRegExp.test(value)){
            return moment(value)
    } 
    if (this.dateRegExpDelphi.test(value)){
        var partes = value.split('/');
        return moment(partes[2]+'-'+partes[1]+'-'+partes[0]);
    }
  }

  getDateFormat(value){
    if (this.dateTimeRegExp.test(value)){
        return 'YYYY-MM-DD 00:00:00';
    } else{
        return 'YYYY-MM-DD';
    }
  }
}