export function registerPrototypes () {
	ObjectPrototypes();
	jQueryPrototypes();
}

function ObjectPrototypes() {
	registerStringPrototypes();
	registerDatePrototypes();
}

function registerStringPrototypes() {
	String.prototype.removeDiacritics = function() {
    return this.normalize("NFD").replace(/[\u0300-\u036f]/g, "");
	}
}

function registerDatePrototypes() {
	Date.prototype.addDays = function (days) {
		var dat = new Date(this.valueOf());
		dat.setDate(dat.getDate() + days);
		return dat;
	}
	
	Date.prototype.yyyymmdd = function () {
		var mm = this.getMonth() + 1; // getMonth() is zero-based
		var dd = this.getDate();
	
		return [this.getFullYear(),
		(mm > 9 ? '' : '0') + mm,
		(dd > 9 ? '' : '0') + dd
		].join('-');
	};
}

function jQueryPrototypes() {
	$.fn.exists = function() {
		return this.length ? this : false;
	}
}