﻿const qAjax = (() => {

    return {
        onBegin() {
            mApp.blockPage();
        },

        onComplete() {
            mApp.unblockPage();
        },

        onFailure() {
            qNotifier.error("Ocorreu um erro na requisição, entre em contato com a administração!", "Ops...");
        },

        onSuccess(data) {
            if (data.redirectUrl != null) {
                if (data.redirectUrl === "reload") {
                    window.location.reload();
                } else {
                    window.location.href = data.redirectUrl;
                }

                return;
            }

            qGrid.refreshAllGrids();
            mApp.initComponents();
            qForm.initPlugins();

            if (data.mensagem) {
                (data.sucesso === true)
                    ? qNotifier.success(data.mensagem)
                    : qNotifier.error(data.mensagem);
            }

            $(data).find("form").each((index, element) => {
                const selector = `#${$(element).attr("id")}`;

                $.validator.unobtrusive.parse($(selector));
            });
        }
    };

})();