const qFavorite = (()=>{
    const $elem = $('.favorite-page');
	
	const handleFavorites = () => {
        const favoriteSucess = (currentFavorite, element) => {

            const role = element.data("role");

            if (element.hasClass("selected")) {
                element.removeClass("selected");
                $('.menu-subnav-favorite[data-favorite="'+role+'"]').remove();
                return;
            }
            element.addClass("selected");
            var html = '<li data-favorite="'+ currentFavorite.role +'" ' + 
                       '    class="menu-item page-favorite-item" ' + 
                       '    aria-haspopup="true" ' +
                       '    data-menu-descricao="'+ currentFavorite.name +'" ' +
                       '    kt-menu-link-redirect="1"> ' +
                       '  <a tabindex="2" href="'+ currentFavorite.url +'" class="menu-link menu-toggle">' +
                       '    <span class="menu-text app-module-menu">'+ currentFavorite.name +
                       '    </span> ' +
                       '  </a> ' +
                       '</li>';

            $(".menu-subnav-favorite").append(html);            
        };

        const favoriteClick = e => {
			fovoritename = 'favoritePages' + SessionManager.moduloAtual;
			
            const $this = $(e.target).closest("a");
            KTApp.block("body");
            var prevFavorites,
                pageurl = $this.data('page-url'),
                pagename = $this.data('page-name'),
                pagerole = $this.data('role');
            
            var currentFavorite = {
                url: pageurl,
                name: pagename,
                role: pagerole
            }


            prevFavorites = (localStorage.getItem(fovoritename) && (localStorage.getItem(fovoritename) != 'undefined') && (typeof localStorage.getItem(fovoritename)!=='undefined')) 
                ? JSON.parse(localStorage.getItem(fovoritename))
                : [];
            
            var exists = false;
            $.each(prevFavorites,function(i,item){
                if(item.url == currentFavorite.url){
                    exists = true;
                    return false;
                }
            });

            if(!exists){
                prevFavorites.push(currentFavorite);
                qNotifier.success("Página adicionada aos seus favoritos!", "Sucesso");
                alterarDescricaoBotao(false);
            }else{
                prevFavorites = jQuery.grep(prevFavorites, function(value) {
                    return value.url != currentFavorite.url;    
                });
                qNotifier.success("Página removida dos seus favoritos!", "Sucesso");
                alterarDescricaoBotao(true);
            }
            
            localStorage.setItem(fovoritename, JSON.stringify(prevFavorites));
			var savestring = btoa(localStorage.getItem(fovoritename)).replace(/=/g, '');
			$.ajax({
				type: 'POST',
				url: "nHttpServicos/UpdateFavoritos?_AFavoritos="+savestring,
				cache: false,						
				error: function (jqXHR, textStatus, errorThrown) {
					qNotifier.error('Falha ao atualizar os favoritos: '+ errorThrown);
				}		
			});
            
            KTApp.unblock();
			
            favoriteSucess(currentFavorite, $this);
			CheckItens(prevFavorites);			
        };

        $(".favorite-page").on("click", favoriteClick);
    };
	
	function CheckItens(_AFavoritos){
        if (_AFavoritos) {
            if (_AFavoritos.length == 0){
                $(".menu-item-clear").show();
                limparFavoritos();
            } else {
                $(".menu-item-clear").hide();
            }    
        }
    }
    
    function alterarDescricaoBotao(adicionar){
        if (adicionar) {
            $('.favorite-page').attr('data-content', 'Clique para adicionar a página aos favoritos.');
            $('.favorite-page').find('i').removeClass('la-star');
            $('.favorite-page').find('i').addClass('la-star-o');
        } else {
            $('.favorite-page').attr('data-content', 'Clique para remover a página dos favoritos.');
            $('.favorite-page').find('i').removeClass('la-star-o');
            $('.favorite-page').find('i').addClass('la-star');
        }
    } 

    function limparFavoritos(){ 
        $(".page-favorite-item").each(function(i){          
            $(this).hide(); 
        });
    }

    function initialize(){ 
        fovoritename = 'favoritePages' + SessionManager.moduloAtual;
		
        if(localStorage.getItem(fovoritename) != 'undefined' && typeof localStorage.getItem(fovoritename) !== 'undefined'){
            var role = $elem.data('role');
            var favoritePages = JSON.parse(localStorage.getItem(fovoritename));
            $.each(favoritePages,function(i,item){
                if ($('.favorite-page').attr('data-page-name') == item.name) {
                    alterarDescricaoBotao(false);
                }
                if(item.role==role && !$elem.hasClass('selected')){
                    $elem.addClass('selected');
                }
                
                var html = '<li data-favorite="'+ item.role +'" ' + 
                           '    class="menu-item page-favorite-item" ' + 
                           '    aria-haspopup="true" ' +
                           '    data-menu-descricao="'+ item.name +'" ' +
                           '    kt-menu-link-redirect="1"> ' +
                           '  <a tabindex="2" href="'+ item.url +'" class="menu-link menu-toggle">' +
                           '    <span class="menu-text app-module-menu">'+ item.name +
                           '    </span> ' +
                           '  </a> ' +
                           '</li>';

                $(".menu-subnav-favorite").append(html);

            });
			CheckItens(favoritePages);
        }
    }
	
	function RequestFavoritos(){
        if (!SessionManager.selecao) return;

		$.ajax({
			type: 'GET',
			url: "nHttpServicos/GetFavoritos",
			cache: false,		
			success: function (request) {
				if (request.Result){
					localStorage.setItem('favoritePages' + SessionManager.moduloAtual, atob(request.Result));				
				}
				else{
					localStorage.setItem('favoritePages' + SessionManager.moduloAtual, JSON.stringify([]));				
				}
				initialize();
			    handleFavorites();
			},
			error: function (jqXHR, textStatus, errorThrown) {
				qNotifier.error('Falha ao buscar favoritos: '+ errorThrown);
			}		
		});
	}

    return {
        init(){
            if($elem.length>0){
                $(document).ready(function(){
                    $elem.attr('data-page-url',window.location.pathname+window.location.search);                
                });                
            }
			RequestFavoritos();			
        }
    }
})();
qFavorite.init();