﻿const qNotifier = (() => {

    const defaultOptions = {
        "closeButton": false,
        "debug": false,
        "newestOnTop": false,
        "progressBar": false,
        "positionClass": "toast-top-right",
        "preventDuplicates": false,
        "onclick": null,
        "showDuration": "300",
        "hideDuration": "1000",
        "timeOut": "5000",
        "extendedTimeOut": "1000",
        "showEasing": "swing",
        "hideEasing": "linear",
        "showMethod": "fadeIn",
        "hideMethod": "fadeOut"
    };

    const fixMessage = message => message.replace(/\\n/g, "<br />");
    
    const getOptions = (options) => {
        return Object.assign({}, defaultOptions, options);
    }

    return {
        success(message, title, options) {
            toastr.success(fixMessage(message), title, getOptions(options));
        },

        info(message, title, options) {
            toastr.info(fixMessage(message), title, getOptions(options));
        },

        warning(message, title, options) {
            toastr.warning(fixMessage(message), title, getOptions(options));
        },

        error(message, title, options) {
            toastr.error(fixMessage(message), title, getOptions(options));
        },

        exception(data) {
            console.log(data);
        },

        clear(){
            toastr.clear();
        }
    };

})();