﻿const qUtils = (() => {

    return {
        cepCallback(data) {
            if (data == null) {
                qNotifier.warning("O CEP informado não foi encontrado!");
                return;
            }

            $("input[name='Endereco.Bairro']").val(data.bairro);
            $("input[name='Endereco.Logradouro']").val(data.logradouro);
            $("input[name='Endereco.Complemento']").val(data.complemento);

            if (data.localidadeid !== "") {
                $("select[name='Endereco.CidadeId']").append($("<option>",
                    {
                        value: data.localidadeid,
                        text: data.localidade
                    }));
                $("select[name='Endereco.CidadeId']").val(data.localidadeid).trigger("change");
            } else {
                $("select[name='Endereco.CidadeId']").val(null).trigger("change");
            }
        },

        cnpjCallback(data) {
            if (data == null) {
                qNotifier.warning("O CNPJ informado não foi encontrado no site da RFB!");
                return;
            }

            $("input[name='RazaoSocial']").val(data.nome);
            $("input[name='NomeFantasia']").val(data.fantasia !== "" ? data.fantasia : data.nome);

            $("input[name='Endereco.Cep']").val(data.cep);
            $("input[name='Endereco.Bairro']").val(data.bairro);
            $("input[name='Endereco.Logradouro']").val(data.logradouro);
            $("input[name='Endereco.Numero']").val(data.numero);
            $("input[name='Endereco.Complemento']").val(data.complemento);

            if (data.municipioid !== "") {
                $("select[name='Endereco.CidadeId']").append($("<option>",
                    {
                        value: data.municipioid,
                        text: data.municipio
                    }));
                $("select[name='Endereco.CidadeId']").val(data.municipioid).trigger("change");
            } else {
                $("select[name='Endereco.CidadeId']").val(null).trigger("change");
            }

            $("input[name='Contato.NumeroTelefonico']").val(data.telefone);
            $("input[name='Contato.Email']").val(data.email);
        },

        checkCondition(val1, condition, val2) {
            switch (condition) {
            case 0:
                return (val1 == val2);
            case 1:
                return (val1 != val2);
            case 2:
                return (val1 > val2);
            case 3:
                return (val1 >= val2);
            case 4:
                return (val1 < val2);
            case 5:
                return (val1 <= val2);
            default:
                return false;
            }
        },

        camelize(str) {
            return str.replace(/(?:^\w|[A-Z]|\b\w|\s+)/g,
                (match, index) => {
                    if (+match === 0)
                        return "";

                    return index === 0 ? match.toLowerCase() : match.toUpperCase();
                });
        },

        findInputByName(name) {
            let $element = $(`[name='${name}']:not(:hidden)`);

            if ($element.length > 1)
                $element = $(`[name='${name}']:checked`);

            return $element;
        },

        getInputValue(element) {
            const $element = this.findInputByName(element);
            const type = $element.attr("type");

            if (type === "checkbox")
                return $element.is(":checked");

            if (type === "radio")
                return $element.val();

            const value = this.numeral($element.val());

            return (value != null) ? value : $element.val();
        },

        switchClass(element, classFrom, classTo) {
            const $element = $(element);

            $element.removeClass(classFrom);

            if (!$element.hasClass(classTo))
                $element.addClass(classTo);
        },

        numeral(value) {
            return numeral(value).value();
        },

        toggleButtonLoading(selector) {
            const $element = $(selector);

            if ($element.hasClass("kt-loader")) {
                $element.removeClass("kt-loader kt-loader--light kt-loader--right").removeAttr("disabled");
            } else {
                $element.addClass("kt-loader kt-loader--light kt-loader--right").attr("disabled", "disabled");
            }
        },

        introJs() {
            const intro = introJs();

            intro.setOptions(
                {
                    "doneLabel": "Finalizar",
                    "nextLabel": "Próximo",
                    "prevLabel": "Voltar",
                    "skipLabel": "Pular",
                    "showProgress": "true"
                }
            );

            return intro;
        },

        scrollTo(selector) {
            var menuHeight = $('#kt_header').height() + $("#kt_subheader").height();
                KTUtil.scrollTo($(selector).get(0), $(selector).offset().top - menuHeight, 500)
            },

        loading: (() => {
            return {
                show(message) {
                    swal({
                        text: message || "Aguarde, carregando.",
                        onOpen: () => swal.showLoading()
                    });
                },

                close: () => swal.close()
            };
        })()
    };

})();