import { JSDOM } from 'jsdom';

export class DOMBuilder {
	static async build(pathToHtml) {
		return pathToHtml ?
			await JSDOM.fromFile(pathToHtml) :
			new JSDOM(`<!DOCTYPE html><html><head></head><body></body></html>`);
	}

	static async includeGlobalsJq(dom) {
		const { window } = dom;
		const { document } = window;

		global.$ = global.jQuery = (await import('jquery')).default(window); // Must be instantiated before leaking window/document

		global.window = window;
		global.document = document;
	}

	static clearGlobals() {
		global.window = null;
		global.document = null;
		global.$ = null;
		global.jQuery = null;
	}
}