import { expect } from 'chai';
import { Acronym } from '../../../js/Utils/Acronym';


describe('Criação de acrônimos', function () {
	it('Deve criar um acrônimo para "teste"', function () {
		let opt = {
			str: 't,e.s t;e',
			separator: [',', '.', ';', ' '],
			length: 10
		};

		expect(Acronym(opt)).to.be.equal('teste');
	});

	it('Deve criar um acrônimo para "Perdido"', function () {
		let opt = {
			str: 'Para, este recibo; de; instrução ( de ortogonal)',
			separator: [',', ' ', ';', '(', ')'],
			length: 10
		};

		expect(Acronym(opt)).to.be.equal('Perdido');
	});

	it('Deve criar um acrônimo para "PASSOU"', function () {
		let opt = {
			str: 'Pcbzxcmv$ A Sncn/S+Oczx-Ue',
			separator: [' ', '$', '+', '/', '-'],
			length: 10
		};

		expect(Acronym(opt)).to.be.equal('PASSOU');
	});

	it('Deve criar um acrônimo pra "Acc"', function() {
		let opt = {
			str: 'A-cs c',
			separator: [' ', '-', '(', ')'],
			length: 10
		}

		expect(Acronym(opt)).to.be.equal('Acc');
	})
});