import { expect } from "chai";
import { JSDOM } from "jsdom";
import { NtcActBlob } from "../../../../../ts/components/fra-control/ntc-act-blob/ntc-act-blob";
import { DOMBuilder } from "../../../../Utils/DOMBuilder";
import { nomeArquivoField } from "./field-config/nome-arquivo-field";

describe('Criação dinâmica do controle ntcActBlob', () => {
    let DOM: JSDOM;

    before(async () => {
        DOM = await DOMBuilder.build();
        await DOMBuilder.includeGlobalsJq(DOM);
    });

    after(DOMBuilder.clearGlobals);

    it('Deve criar os elementos do controle', () => {
        const element = NtcActBlob(nomeArquivoField);

        let label = element.find('label#labelctrloptNOMEARQUIVOBLOB');
        let divCol = element.children().eq(1);
        let inputGroup = divCol.find('div.input-group');
        let input = inputGroup.find('input#ctrlNOMEARQUIVOBLOB');
        let importButton = inputGroup.find('div').eq(0);
        let importButtonText = importButton.find('span');
        let exportButton = inputGroup.find('div').eq(1);
        let exportButtonText = exportButton.find('span');

        expect(label.length).to.equal(1);
        expect(divCol.length).to.equal(1);

        expect(inputGroup.length).to.equal(1);
        expect(input.length).to.equal(1);

        expect(importButton.length).to.equal(1);
        expect(importButtonText.length).to.equal(1);
        expect(importButtonText.html()).to.equal('Importar');

        expect(exportButton.length).to.equal(1);
        expect(exportButtonText.length).to.equal(1);
        expect(exportButtonText.html()).to.equal('Exportar');
    });
});