import { expect } from "chai";
import { JSDOM } from "jsdom";
import { NtcActBuscarCEP } from "../../../../../ts/components/fra-control/ntc-act-buscar-cep/ntc-act-buscar-cep";
import { DOMBuilder } from "../../../../Utils/DOMBuilder";
import { actBuscarCEPField } from "./field-config/act-buscar-cep-field";

describe('Criação dinâmica do controle ntcActBuscarCEP', () => {
    let DOM: JSDOM;

    before(async () => {
        DOM = await DOMBuilder.build();
        await DOMBuilder.includeGlobalsJq(DOM);
    });

    after(DOMBuilder.clearGlobals);

    it('Deve criar os elementos do controle', () => {
        const element = <JQuery<HTMLElement>>NtcActBuscarCEP(actBuscarCEPField);

        let label = element.find('label#labelctrloptCEP');
        let divCol = element.children().eq(1);
        let inputWrapper = divCol.find('div.input-group.input-addon-default');
        let input = inputWrapper.find('input#ctrlCEP');
        let buttonWrapper = divCol.find('div.input-group-append');
        let button = buttonWrapper.find('button#btnCEP');

        expect(label.length).to.equal(1);
        expect(divCol.length).to.equal(1);

        expect(inputWrapper.length).to.equal(1);
        expect(input.length).to.equal(1);
        expect(buttonWrapper.length).to.equal(1);
        expect(button.length).to.equal(1);
    });
});