import { expect } from "chai";
import { JSDOM } from "jsdom";
import { NtcCheckListBoxHorizontal } from "../../../../../ts/components/fra-control/ntc-check-list-box-horizontal/ntc-check-list-box-horizontal";
import { DOMBuilder } from "../../../../Utils/DOMBuilder";
import { outrasInformacoesField } from "./field-config/outras-informacoes-field";

describe('Criação dinâmica do controle ntcCheckListBoxHorizontal', () => {
    let DOM: JSDOM;

    before(async () => {
        DOM = await DOMBuilder.build();
        await DOMBuilder.includeGlobalsJq(DOM);
    });

    after(DOMBuilder.clearGlobals);

    it('Deve criar os elementos do controle', () => {
        const element = <JQuery<HTMLElement>>NtcCheckListBoxHorizontal(outrasInformacoesField);

        let label = element.find('label#labelctrloptLISTARELATORIOGER');
        let divCol = element.children().eq(1);
        let checkboxWrapper = divCol.find('div#ctrlLISTARELATORIOGERcheck');

        let labelCheckbox = checkboxWrapper.find('label.checkbox');
        let inputVisual = labelCheckbox.find('input[type=checkbox]');

        expect(label.length).to.equal(1);
        expect(divCol.length).to.equal(1);

        expect(checkboxWrapper.length).to.equal(1);
        expect(labelCheckbox.length).to.equal(16);
        expect(inputVisual.length).to.equal(16);

        expect(divCol.hasClass('ntcCheckListBox')).to.be.false;
        expect(divCol.hasClass('ntcCheckListBoxHorizontal')).to.be.true;

        expect(checkboxWrapper.hasClass('checkbox-inline')).to.be.true;
    });
});