import { expect } from "chai";
import { JSDOM } from "jsdom";
import { NtcCheckListBox } from "../../../../../ts/components/fra-control/ntc-check-list-box/ntc-check-list-box";
import { DOMBuilder } from "../../../../Utils/DOMBuilder";
import { checkListBoxField } from "./field-config/check-list-box-field";

describe('Criação dinâmica do controle ntcCheckListBox', () => {
    let DOM: JSDOM;

    before(async () => {
        DOM = await DOMBuilder.build();
        await DOMBuilder.includeGlobalsJq(DOM);
    });

    after(DOMBuilder.clearGlobals);

    it('Deve criar os elementos do controle', () => {
        const element = <JQuery<HTMLElement>>NtcCheckListBox(checkListBoxField);

        let label = element.find('label#labelctrloptPTIPOLANCAMENTO');
        let divCol = element.children().eq(1);
        let checkboxWrapper = divCol.find('div.checkbox-wrapper#ctrlPTIPOLANCAMENTOcheck');


        let labelCheckbox = checkboxWrapper.find('label.kt-checkbox');
        let inputVisual = labelCheckbox.find('input[type=checkbox]');

        expect(label.length).to.equal(1);
        expect(divCol.length).to.equal(1);
        expect(divCol.hasClass('ntcCheckListBox')).to.equal(true);

        expect(checkboxWrapper.length).to.equal(1);
        expect(labelCheckbox.length).to.equal(3);
        expect(inputVisual.length).to.equal(3);
    });

 
});