import { expect } from "chai";
import { JSDOM } from "jsdom";
import { NtcHistorico } from "../../../../../ts/components/fra-control/ntc-historico/ntc-historico";
import { DOMBuilder } from "../../../../Utils/DOMBuilder";
import { complementoField } from "./field-config/complemento-field";

describe('Criação dinâmica do controle ntcHistorico', () => {
    let DOM: JSDOM;

    before(async () => {
        DOM = await DOMBuilder.build();
        await DOMBuilder.includeGlobalsJq(DOM);
    });

    after(DOMBuilder.clearGlobals);

    it('Deve criar os elementos do controle', () => {
        const element = NtcHistorico(complementoField);

        let label = element.find('label#labelctrloptCOMPLHIST');
        let divCol = element.children().eq(1);
        let inputHidden = divCol.find('input#ctrlCOMPLHIST');
        let divComplemento = divCol.find('div#divComplHist.divComplHist');

        expect(label.length).to.equal(1);
        expect(divCol.length).to.equal(1);

        expect(inputHidden.length).to.equal(1);
        expect(divComplemento.length).to.equal(1);
    });
});