import { expect } from "chai";
import { JSDOM } from "jsdom";
import { NtcImage } from "../../../../../ts/components/fra-control/ntc-image/ntc-image";
import { DOMBuilder } from "../../../../Utils/DOMBuilder";
import { ntcImageField } from "./field-config/ntc-image-field";

describe('Criação dinâmica do controle ntcImage', () => {
    let DOM: JSDOM;

    before(async () => {
        DOM = await DOMBuilder.build();
        await DOMBuilder.includeGlobalsJq(DOM);
    });

    after(DOMBuilder.clearGlobals);

    it('Deve criar os elementos do controle', () => {
        const element = <JQuery<HTMLElement>>NtcImage(ntcImageField);

        let label = element.find('label#labelctrloptFOTOTERC');
        let divCol = element.children().eq(1);
        let wrapper = divCol.find('div.align-items-top');
        let inputWraper = wrapper.find('div.custom-file');
        let input = inputWraper.find('input#ctrlFOTOTERC[type="file"]');
        let inputImage = wrapper.find('input#ctrlImgFOTOTERC[type="image"]')

        expect(label.length).to.equal(1);
        expect(divCol.length).to.equal(1);

        expect(wrapper.length).to.equal(1);
        expect(inputWraper.length).to.equal(1);
        expect(input.length).to.equal(1);
        expect(inputImage.length).to.equal(1);
    });
});