import { expect } from "chai";
import { JSDOM } from "jsdom";
import { NtcMemo } from "../../../../../ts/components/fra-control/ntc-memo/ntc-memo";
import { DOMBuilder } from "../../../../Utils/DOMBuilder";
import { descricaoCompletaField } from './field-config/descricao-completa-field';

describe('Criação dinâmica do controle ntcMemo', () => {
    let DOM: JSDOM;

    before(async () => {
        DOM = await DOMBuilder.build();
        await DOMBuilder.includeGlobalsJq(DOM);
    });

    after(DOMBuilder.clearGlobals);

    it('Deve criar os elementos do controle', () => {
        const element = <JQuery<HTMLElement>>NtcMemo(descricaoCompletaField);

        let label = element.find('label#labelctrloptDESCRCOMPLCONTA');
        let divCol = element.children().eq(1);
        let textarea = divCol.find('textarea#ctrlDESCRCOMPLCONTA');

        expect(label.length).to.equal(1);
        expect(divCol.length).to.equal(1);

        expect(textarea.length).to.equal(1);
    });
});