import { expect, assert} from 'chai';

import { UrlParamBuilder } from '../../../js/UrlParamBuilder';

describe("UrlParamBuilder Tests:", function () {
  it('Teste URL', async function () {
    var teste = new UrlParamBuilder('testeurl');
    expect(teste.buildUrl()).to.equal('testeurl');
  })

	it('Teste URL um parâmetro', async function () {
    var teste = new UrlParamBuilder('testeurl');
		teste.addParam('_ATeste', 50);
    expect(teste.buildUrl()).to.equal('testeurl?_ATeste=50');
  })

	it('Teste URL dois parâmetro', async function () {
    var teste = new UrlParamBuilder('testeurl');
		teste.addParam("_ATeste", 50);
		teste.addParam("_ANome", "Nombre");
    expect(teste.buildUrl()).to.equal('testeurl?_ATeste=50&_ANome=Nombre');
  })

	it('Teste URL 3 parâmetro', async function () {
    var teste = new UrlParamBuilder('testeurl');
		teste.addParam("_ATeste", 50);
		teste.addParam("_ANome", "Nombre");
		teste.addParam("_AValor", 40);
    expect(teste.buildUrl()).to.equal('testeurl?_ATeste=50&_ANome=Nombre&_AValor=40');
  })

});