import { expect, assert } from 'chai';
import WizardManager from '../../../js/WizardManager';

describe("WizardManager", function () {
	it (`Evento customizado deve ser adicionado corretamente`, function() {
		let handler = function() { return 1 };

		WizardManager.setCustomEvent("CustomEvent", handler);
		expect(WizardManager.getCustomEvent("CustomEvent")).to.be.equal(handler);
	});

	it(`Evento customizado deve retornar true`, function () {
		let testVar = null;
		const handler = function () { testVar = true };
		const context = { 
			Class: "Wizard",
			Params: { "IDCAPTCHA": "846" },
			Datasets: null,
			DetalheHome: "home",
			DetalheAnterior: "",
			DetalheProximo: "step1",
			DetalheAtivo: "home"
		};

		WizardManager.setContext(context);
		WizardManager.setCustomEvent("home", handler);
		WizardManager.GoToWizardNext('step1')
		expect(testVar).to.be.true;
	})

	it(`Evento customizado deve lançar excecao "GoToWizardNext not defined"`, function () {
		const handler = function () { return true };
		const context = { 
			Class: "Wizard",
			Params: { "IDCAPTCHA": "846" },
			Datasets: null,
			DetalheHome: "home",
			DetalheAnterior: "home",
			DetalheProximo: "step2",
			DetalheAtivo: "step1"
		};

		WizardManager.setContext(context);
		WizardManager.setCustomEvent("home", handler);

		expect(() => WizardManager.GoToWizardNext('step1')).to.throw("GoToWizardItem is not defined")
	})

});
