import { expect, assert} from 'chai';

import { condExpressionValidator } from '../../../js/condExpressionValidator';

describe("Cond Logic Validators", function () {
  let getField = (field, fieldName) => field[fieldName];
  
  it(`Expression should be True`, function () {
    let expr = "condAND(condIGUAL('field1', 2), condIGUAL('field2', 4))";
    let field = {field1: 2, field2: 4};
    let validator = new condExpressionValidator(expr, getField, field)

    expect(validator.execute()).to.equal(true);
  })

  it('condAND -> true', function() {
    let expr = "condAND(true, true)";
    let validator = new condExpressionValidator(expr, getField, {})

    expect(validator.execute()).to.equal(true);
  })
  it('condAND -> false', function() {
    let expr = "condAND(false, true)";
    let validator = new condExpressionValidator(expr, getField, {})

    expect(validator.execute()).to.equal(false);
  })
  it('condAND -> false', function() {
    let expr = "condAND(true, false)";
    let validator = new condExpressionValidator(expr, getField, {})

    expect(validator.execute()).to.equal(false);
  })

  it('condAND -> false', function() {
    let expr = "condAND(false, false)";
    let validator = new condExpressionValidator(expr, getField, {})

    expect(validator.execute()).to.equal(false);
  })

  it('condIGUAL 4 == 4 : true', function() {
    let expr = "condIGUAL('field', 4)";
    let validator = new condExpressionValidator(expr, getField, {field: 4})

    expect(validator.execute()).to.equal(true);
  })

  it('condIGUAL 2 == 4 : false', function() {
    let expr = "condIGUAL('field', 4)";
    let validator = new condExpressionValidator(expr, getField, {field: 2})

    expect(validator.execute()).to.equal(false);
  })

  it('condIGUAL 4 == 2 : false', function() {
    let expr = "condIGUAL('field', 2)";
    let validator = new condExpressionValidator(expr, getField, {field: 4})

    expect(validator.execute()).to.equal(false);
  })
});