import { expect, use } from 'chai';
import { DOMBuilder } from '../../Utils/DOMBuilder';
import path from 'path';

describe("Criação de um dom para usar nos testes unitários com JsDom a partir de um arquivo html", () => {
	var DOM;

	before(async () => { DOM = await DOMBuilder.build(path.resolve(__dirname, 'jsdom.html')) });

	it('Monta dom a partir de arquivo html', async () => {
		await DOMBuilder.includeGlobalsJq(DOM);

		expect(() => $("body")).to.not.throw()
	});
});

describe("Criação de um dom para usar nos testes unitários com JsDom", () => {
	before(async () => await DOMBuilder.includeGlobalsJq(await DOMBuilder.build()));

	it('Deve instanciar jquery', async () => {
		jQuery('body').append('<div id="test"></div>');

		const result = $('#test').get(0);
		const expectedDiv = document.getElementById('test');

		expect(typeof window).to.be.equal('object');
		expect(typeof document).to.be.equal('object');
		expect(typeof $).to.be.equal('function');
		expect(typeof jQuery).to.be.equal('function');
		expect(result).to.be.equal(expectedDiv);
	});

	it('Deve atribuir null as variáveis necessárias ao jQuery global: {window, document, $, jQuery}', () => {
		const shouldThrow = () => $('body');
		
		DOMBuilder.clearGlobals();

		expect(window).to.be.null;
		expect(document).to.be.null;
		expect($).to.be.null;
		expect(jQuery).to.be.null;
		expect(shouldThrow).to.throw('$ is not a function');
	});
});