import { expect } from 'chai';
import { nStringToValue } from '../../../js/nStringToValue';

describe("nStringToValue Tests:", function () {
  it('Teste isvalue 0,00', async function () {
    var teste = new nStringToValue();    
    expect(teste.isValue('0,00')).to.equal(true);
  })

  it('Teste isvalue 0,99', async function () {
    var teste = new nStringToValue();    
    expect(teste.isValue('0,99')).to.equal(true);
  })

  it('Teste toValue 0,00', async function () {
    var teste = new nStringToValue();    
    expect(teste.toValue('0.00')).to.equal(0.00);
  })

  it('Teste tovalue 0,99', async function () {
    var teste = new nStringToValue();    
    expect(teste.toValue('0,99')).to.equal(0.99);
  })

  it('Teste isvalue 1.000,00', async function () {
    var teste = new nStringToValue();    
    expect(teste.isValue('1.000,00')).to.equal(true);
  })

  it('Teste tovalue 1.000,00', async function () {
    var teste = new nStringToValue();    
    expect(teste.toValue('1.000,00')).to.equal(1000.00);
  })

  it('Teste isvalue 1.000.000,00', async function () {
    var teste = new nStringToValue();    
    expect(teste.isValue('1.000.000,00')).to.equal(true);
  })

  it('Teste tovalue 1.000.000,00', async function () {
    var teste = new nStringToValue();    
    expect(teste.toValue('1.000.000,00')).to.equal(1000000.00);
  })

  it('Teste isvalue 1.000.000.000,00', async function () {
    var teste = new nStringToValue();    
    expect(teste.isValue('1.000.000.000,00')).to.equal(true);
  })

  it('Teste tovalue 1.000.000.000,00', async function () {
    var teste = new nStringToValue();    
    expect(teste.toValue('1.000.000.000,00')).to.equal(1000000000.00);
  })

  it('Teste isvalue "500,00"', async function () {
    var teste = new nStringToValue();    
    expect(teste.isValue('"500,00"')).to.equal(true);
  })

  it('Teste isvalue "5000,00"', async function () {
    var teste = new nStringToValue();    
    expect(teste.isValue('"5000,00"')).to.equal(true);
  })

  it('Teste isvalue "a50,00"', async function () {
    var teste = new nStringToValue();    
    expect(teste.isValue('"a50,00"')).to.equal(false);
  })
  
  it('Teste isvalue "50,00a"', async function () {
    var teste = new nStringToValue();    
    expect(teste.isValue('"50,00a"')).to.equal(false);
  })

  it('Teste isvalue "50,a00"', async function () {
    var teste = new nStringToValue();    
    expect(teste.isValue('"50,a00"')).to.equal(false);
  })

  it('Teste isvalue "50a,00"', async function () {
    var teste = new nStringToValue();    
    expect(teste.isValue('"50a,00"')).to.equal(false);
  })

  it('Teste isvalue "50a,a00"', async function () {
    var teste = new nStringToValue();    
    expect(teste.isValue('"50a,a00"')).to.equal(false);
  })

  it('Teste isvalue "a50a,a00a"', async function () {
    var teste = new nStringToValue();    
    expect(teste.isValue('"a50,a00a"')).to.equal(false);
  })

  it('Teste isvalue "cinquenta"', async function () {
    var teste = new nStringToValue();    
    expect(teste.isValue('"cinquenta"')).to.equal(false);
  })
});