import { FormRepeaterForm } from "../form-repeater";
import { FormRepeaterItem } from "../form-repeater-base";
import { FormRepeaterFields, FormRepeaterFieldsItem } from "../form-repeater-field";
import { ButtonProps, renderButton } from "./buttons";

export const AddButton = (props: ButtonProps): JQuery<HTMLElement> => {
    let buttonEl = renderButton({
        className: 'btn-icon btn-text-dark btn-hover-transparent-dark btn-sm',
        hint: 'Adicionar',
        icon: `la la-plus`,//props.button.icon,
        onClick: () => {
            const newInstance = props.formRepeater?.addInstance({
                item: props.item,
                element: props.formRepeater.getItem(props.uuid)?.element!,
                formProp: props.formProp,
                append: true,
                formInstance: props.formInstance,
                field: props.field!
            });

            if (!newInstance) return;
            focusNextField({
                formRepeater: props.formRepeater!,
                formRepeaterItem: newInstance,
            });
        },
        type: 'button',
        visible: true
    });

    if (props.formRepeater instanceof FormRepeaterForm) {
        props.formInstance!.setAction({
            form: props.formInstance,
            "cadCons": props.formProp.CadCons,
            "topicoAjuda": props.formProp.TopicoAjuda,
            "name": "actDataSetInsertExecute",
            "isDefault": true
        });
    }

    return buttonEl;
}

interface NextFieldProps {
    formRepeater: FormRepeaterForm | FormRepeaterFields;
    formRepeaterItem: FormRepeaterItem;
}

function focusNextField({ formRepeater, formRepeaterItem }: NextFieldProps) {
    const getFirstField = (instance?:  FormRepeaterFieldsItem) => {
        return instance?.fields.find((field) => field.canFocus());
    };

    setTimeout(() => { // await until Field is instantiated
        if (formRepeater instanceof FormRepeaterForm) {
            formRepeaterItem.formComponent.focusFirstField();
        }
        else {
            let field = getFirstField(formRepeaterItem as FormRepeaterFieldsItem);
            
            field?.focus();
        }
    });
}

