import { ButtonProps, renderButton } from "./buttons";

export const DefaultButton = (props: ButtonProps): JQuery<HTMLElement> => {
    let buttonEl = renderButton({
        className: 'btn-secondary btn-icon btn-sm',
        hint: props.button.Hint,
        icon: `la la-${props.button.Name}`,//props.button.icon,
        // onClick: window[props.button.NameEvent as any]
        type: 'button',
        visible: true
    });

    props.formInstance!.setAction({
        elementTrigger: buttonEl.get(0),
        form: props.formInstance,
        ...defaultActionOptions({ ...props, idElement: buttonEl.attr('id')! })
    });

    return buttonEl;
}

export const defaultActionOptions = (props: ButtonProps & { idElement: string }) => ({
    cadCons: props.formProp.CadCons,
    topicoAjuda: props.formProp.TopicoAjuda,
    idElement: props.idElement,
    name: props.button.NameEvent,
    type: 'click',
})