import FormManager from "../../../js/FormManager";
import { Field, GroupColumn, Prop } from "../fra-control/types";
import { FormRepeaterForm } from "./form-repeater";
import { FormRepeaterFields } from "./form-repeater-field";

interface FormRepeaterConfig extends Prop<(Field | GroupColumn)[] | Field> {
    element: HTMLScriptElement
}

export const createFormRepeater = ({ item, formProp, element, formInstance }: FormRepeaterConfig): FormRepeaterForm | FormRepeaterFields => {
    if (isFormRepeaterForm(item)) {
        return new FormRepeaterForm({
            item,
            formProp,
            element: $(element),
        });
    }
    else {
        return new FormRepeaterFields({
            item: item.ntcGridFields!,
            field: item,
            formProp,
            element: $(element),
            formInstance: formInstance || FormManager.byname(formProp.Class, formProp.Alias)
        });
    }
}

function isFormRepeaterForm(item:any): item is (Field | GroupColumn)[] {
    return item instanceof Array;
} 