import { Field, FormProp, GroupColumn, Prop } from "../../../fra-control/types";
import { isGroupColumn } from "../../../fra-control/util/util";

type FormProperties = Prop<(Field | GroupColumn)[]>;

type MapPropertiesUuid = (props: FormProperties, uuid: string) => FormProperties & { isFormRepeater: boolean };

export const uuidMapProperties: MapPropertiesUuid = ({ item, formProp }, uuid) => {
    return {
        item: uuidItemMap(item, uuid),
        formProp: uuidFormPropMap(formProp, uuid),
        isFormRepeater: true,
    }
}

const uuidItemMap = (item: (Field | GroupColumn)[], uuid: string): (Field | GroupColumn)[] => {
    [uuid]
    return item.map(field => {
        if (isGroupColumn(field)) {
            return field;
        }
        else {
            return {
                ...field,
                // Name: `${field.Name}${uuid}`
            }
        }
    })
}

const uuidFormPropMap = (formProp: FormProp, uuid: string): FormProp => {
    [uuid]

    return {
        ...formProp,
        Alias: `${formProp.Alias}_${uuid}`
    };
}