import { ControlElementCreator, Field, Prop, NtcType } from "../types";
import { isGroupColumn } from "../util/util";


export interface InstantiateFieldOption {
	'name': string;
	'is-image': boolean;
	'visible': boolean;
	'index': number;
	'is-multicolumn': boolean;
	'is-groupcolumn': boolean;
	'expressoes': any;
	'ntc-type': NtcType;
	'ntc-subtype': string;
	'nv-valor': string;
}

export const FraControlElement: ControlElementCreator<Field & { nvValor?: string }> = (props) => {
    let element = $('<div>')
        .attr({
            'data-fracontrol-script-create': true,
            'data-classname': props.item.DMClassName,
            'data-alias': props.formProp.Alias || '',
        });

    element.data(getInstantiateFieldOptions(props));

    return element;
}


const getInstantiateFieldOptions = ({ item, formProp }: Prop): InstantiateFieldOption => {
    return {
        'name': `${item.Name}${item.DICDIRETORIOABRIR ? '_DIRABRIR' : ''}`,
        'is-image': item.ntcImage || false,
        'visible': item.Visible,
        'index': item.index!,
        'is-multicolumn': formProp.MultiColuna,
        'is-groupcolumn': isGroupColumn(item),
        'expressoes': item.Expressoes,
        'ntc-type': item.TipoControle,
        'ntc-subtype': item.LinkLookupDescShowFields ? 'lookupAlphaNumeric' : '',
        'nv-valor': (item as any).nvValor ?? null
    }
} 