import { NtcActBlob as getNtcActBlob } from './ntc-act-blob/ntc-act-blob';
import { NtcActBuscarCEP as getNtcActBuscarCEP } from './ntc-act-buscar-cep/ntc-act-buscar-cep';
import { NtcCheckListBoxHorizontal } from './ntc-check-list-box-horizontal/ntc-check-list-box-horizontal';
import { NtcCheckListBox as getNtcCheckListBox } from './ntc-check-list-box/ntc-check-list-box';
import { NtcCheckTreeView as getNtcCheckTreeView } from './ntc-check-tree-view/ntc-check-tree-view';
import { NtcCheckbox as getNtcCheckBox } from './ntc-checkbox/ntc-checkbox';
import { NtcComboBox as getNtcComboBox } from './ntc-combo-box/ntc-combo-box';
import { NtcEdit as getNtcEdit } from './ntc-edit/nct-edit';
import { NtcGrid as getNtcGrid } from './ntc-grid/ntc-grid';
import { NtcHistorico as getNtcHistorico } from './ntc-historico/ntc-historico';
import { NtcImage as getNtcImage } from './ntc-image/ntc-image';
import { NtcLinkAnnotation as getNtcLinkAnnotation } from './ntc-link-annotation/ntc-link-annotation';
import { NtcLinkEdit as getNtcLinkEdit } from './ntc-link-edit/ntc-link-edit';
import { NtcLink as getNtcLink } from './ntc-link/ntc-link';
import { NtcMemo as getNtcMemo } from './ntc-memo/ntc-memo';
import { NtcMemoAnnotation as getNtcMemoAnnotation } from './ntc-memo-annotation/ntc-memo-annotation';
import { ControlElementCreator, Field, GroupColumn, Prop } from "./types";
import { isGroupColumn } from './util/util';
import { DicArquivoAbrir } from './dic-arquivo-abrir/dic-arquivo-abrir';
import { DicDiretorioAbrir } from './dic-diretorio-abrir/dic-diretorio-abrir';
import { NomeArquivoBlobFile } from './nome-arquivo-blob-file/nome-arquivo-blob-file';

/**
 * 
 *  Deve criar o html seguindo a estrutura a seguir
 *  <div id="formField<nome-campo><classe>" class="...">
 *      <label id="labelctrlopt<nome-campo>"" for="ctrl<nome-campo>" class="...">...</label>
 *      <div class="...">
 *          conteudo do campo, select, input, divs....
 *       </div>
 *  </div>
 */

export const FraControl: ControlElementCreator<Field | GroupColumn> = function(props)  {
    let { item } = props;

    if (isGroupColumn(item)) {
        console.log('isGroupColumn');
    } 
    else {
        if (item.ntcActBlob) return getNtcActBlob(props as Prop);
        else if (item.ntcActBuscarCEP) return getNtcActBuscarCEP(props as Prop);
        else if (item.ntcCheckBox) return getNtcCheckBox(props as Prop);
        else if (item.ntcCheckListBox) return getNtcCheckListBox(props as Prop);
        else if (item.ntcCheckListBoxHorizontal) return NtcCheckListBoxHorizontal(props as Prop);
        else if (item.ntcCheckTreeView) return getNtcCheckTreeView(props as Prop);
        else if (item.ntcComboBox) return getNtcComboBox(props as Prop);
        // case "ntcDBRichEditEditor": return getNtcDBRichEditEditor(props);
        else if (item.ntcEdit) return getNtcEdit(props as Prop);
        else if (item.ntcGrid) return getNtcGrid(props as Prop);
        else if (item.ntcHistorio) return getNtcHistorico(props as Prop);
        else if (item.ntcImage) return getNtcImage(props as Prop);
        else if (item.ntcLink) return getNtcLink(props as Prop);
        else if (item.ntcLinkEdit) return getNtcLinkEdit(props as Prop);
        else if (item.ntcMemo) return getNtcMemo(props as Prop);
        else if (item.ntcLinkAnnotation) return getNtcLinkAnnotation(props as Prop);
        else if (item.ntcMemoAnnotation) return getNtcMemoAnnotation(props as Prop);
        else if (item.DICARQUIVOABRIR) return DicArquivoAbrir(props as Prop);
        else if (item.DICDIRETORIOABRIR) return DicDiretorioAbrir(props as Prop);
        else if (item.NOMEARQUIVOBLOBFILE) return NomeArquivoBlobFile(props as Prop);
        // case "ntcRichEdit": return getNtcRichEdit(props);
        // case "ntwDiaComData": return getNtwDiaComData(props);
        // case "ntwEditComLabel": return getNtwEditComLabel(props);
    }

    return $();
}