import classNames from 'classnames';
import { ControlElementCreator } from "../types";
import { InputBlock } from "../input-block/input-block";
import { Label } from "../label/label";
import {  setAttrIfHasValue } from "../util/util";
import { FraControlElement } from "../fra-control-element/fra-control-element";
import { loadBase64File } from "../../../../js/nArquivos";

declare var focusImputFunc: any;

export const NomeArquivoBlobFile: ControlElementCreator = (props) => {
    const inputBlock = InputBlock(props);
    const label = Label(props);
    const input = getInput(props);
    const controlElement = FraControlElement(props);

    return inputBlock
        .append(label)
        .append(input)
        .append(controlElement);
};

const getInput: ControlElementCreator = (props) => {
    const { formProp, item } = props;
    const input = $(`<input />`)
        .attr({
            'data-alias': formProp.Alias || '',
            'data-classname': item.DMClassName,
        })
        .on('focus', (event) => { focusImputFunc({ element: event.target }) })
        .on('change', (event) => {
            const files = (event.target as HTMLInputElement).files;
            
            $(".ntcActBlob").val(files ? files[0].name : '');
            loadBase64File(files, item.Name, item.DMClassName, formProp.Alias || '');
        });

    setAttrIfHasValue(input, {
        accept: item.Filter,
        autocomplete: 'off',
        class: classNames({
            'form-control kt-input custom-file-input cad-control cad-logchange hide NOMEARQUIVOBLOBFILE': true,
            [`${item.ControlClass}`]: item.ControlClass,
            [`ctrl${item.Name}`]: true,
        }),
        disabled: item.disabled,
        id: `ctrl${item.Name}`,
        name: `p.${item.Name}`,
        required: item.Required,
        step: 'any',
        title: item.Hint,
        type: 'file',
        value: item.Valor,
        'data-AutoIncrementar': item.AutoIncrementar,
        'data-Dicionario': item.Dicionario,
    });

    return input;
};
