import { ControlElementCreator, Field } from "../types"
import { getFormId, setAttrIfHasValue } from "../util/util";

declare var focusImputFunc: any;

export const DefaultInput: ControlElementCreator = (props) => {
    const { item, formProp } = props

    let classList = getClassList(item);

    let el = $('<input />')
        .attr({
            'data-alias': formProp.Alias,
            'data-classname': item.DMClassName,
        })
        .on('focus', function(event) { focusImputFunc({ element: event.target }) });
    
    setAttrIfHasValue(el, {
        autocomplete: "off",
        class: classList,
        disabled: item.disabled,
        form: getFormId(formProp),
        id: `ctrl${item.Name}`,
        maxlength: (item.DisplayWidth || null),
        name: `p.${item.Name}`,
        readonly: item.ReadOnly,
        required: item.Required,
        step: "any",
        style: item.TextCase,
        title: item.Hint,
        type: item.InputType,
        value: item.Valor,
        'data-autoincrementar': item.AutoIncrementar,
        'data-dicionario': item.Dicionario,
    });

    return el;
}

function getClassList({ ControlClass, Name, SearchStyle }: Field) {
    let def = 'form-control kt-input cad-control cad-logchange';
    let control = `${ControlClass ?? ''} ctrl${Name}`;
    let searchStyle = SearchStyle ? 'border-radius-left border-radius-right form-control-search' : '';

    return `${def} ${control} ${searchStyle}`.trim();
}