import { ControlElementCreator, Field } from "../types";
import { getFormId, setAttrIfHasValue } from "../util/util";
import classNames from 'classnames';

declare var focusImputFunc: any;

export const MaskedInput: ControlElementCreator = (props) => {
    const { item, formProp } = props;

    let classList = getClassList(item);

    let el = $('<input />')
        .attr({
            'data-alias': formProp.Alias,
            'data-classname': item.DMClassName,
        })
        .on('focus', function(event) { focusImputFunc({ element: event.target }) });

    setAttrIfHasValue(el, {
        autocomplete: "off",
        class: classList,
        disabled: item.disabled,
        form: getFormId(formProp),
        id: `ctrl${item.Name}`,
        name: `p.${item.Name}`,
        required: item.Required,
        readonly: item.ReadOnly,
        step: "any",
        style: item.TextCase,
        title: item.Hint,
        type: item.InputType,
        value: item.Valor,
        'data-autoincrementar': item.AutoIncrementar,
        'data-dicionario': item.Dicionario,
        'data-mask': item.mask,
        'data-mask-reverse': item.maskreverse,
    });

    return el;
}   

function getClassList({ ControlClass, Name, SearchStyle }: Field) {
    return classNames({
        'form-control kt-input cad-control cad-logchange': true,
        'border-radius-left border-radius-right form-control-search': SearchStyle,
        [`ctrl${Name}`]: true,
        [`${ControlClass}`]: ControlClass,
    })
}