import { ControlElementCreator } from "../types";
import { InputBlock } from "../input-block/input-block";
import { Label } from "../label/label";
import { FraControlElement } from "../fra-control-element/fra-control-element";
import { createFormRepeater } from "../../form-repeater/create-form-repeater";
import FormManager from "../../../../js/FormManager";

export const NtcGrid: ControlElementCreator = (props) => {
    const { item, formProp, formInstance } = props;

    let inputBlock = InputBlock(props);
    let label = Label(props);
    let controlElement = FraControlElement(props);
    let element = $('<div>');

    item.ntcGridFields?.forEach((field) => field['DMClassName'] = item.DMClassName);

    /**
     * ForRepeater fields must be created after all other static 
     * fields has been created. Dependes on the field with type ntcGrid
     */

    if (formInstance) { //when comes from fra-control.ts
        formInstance.afterCreateStaticFields.subscribe(() => {
            createFormRepeater({
                item,
                formProp,
                element: element.get(0) as HTMLScriptElement,
                formInstance
            });
        })
    }
    else { // when comes directly from html throught create-ntc-grid.ts
        let subs = FormManager.afterCreateAllForms.subscribe(() => {
            subs.unsubscribe();
            
            createFormRepeater({
                item,
                formProp,
                element: element.get(0) as HTMLScriptElement,
                formInstance
            });
        });
    }

    return inputBlock
        .append(label)
        .append(element)
        .append(controlElement);
}