import { ControlElementCreator, Field } from "../types";
import { setAttrIfHasValue } from "../util/util";

declare var AbrirCadastro: any;

export const getButtons: ControlElementCreator = (props) => {
    let { formProp, item } = props;
    let wrapper = $('<div class="input-group-append">');
    let buttonSearch = getButtonSearch(props);

    wrapper.append(buttonSearch);

    if (formProp.sessionSelecao && !item.SearchStyle && item.LinkDirecionaCadastro) {
        let buttonAdd = getButtonAdd(props);
        
        wrapper.append(buttonAdd);
    }

    return wrapper;
}

const getButtonAdd: ControlElementCreator = ({ item }) => {
    let icon = $('<i class="la la-plus">');
    let button = $('<button>')
        .on('click', () => AbrirCadastro(item.Cadastro, true, ''))
        .append(icon);

    setAttrIfHasValue(button, {
        class: 'input-group-text btn btn-text-dark btn-hover-transparent-dark',
        disabled: item.disabled,
        style: 'border-color: #ababab;',
        tabindex: '-1',
        title: '',
        type: 'button',
        'data-original-title': 'Incluir um Novo',
        'data-toggle': 'kt-tooltip'
    });

    return button;
}

const getButtonSearch: ControlElementCreator = ({ item, formProp }) => {
    let classList = getButtonSearchClassList(item);
    let icon = $('<i class="la la-search">').addClass(item.SearchStyle ? 'border-radius-left icon-blue' : '');
    let button = $('<button>').append(icon);

    setAttrIfHasValue(button, {
        class: classList,
        disabled: item.disabled,
        style: 'border-color: #ababab;',
        tabindex: '-1',
        type: 'button',
        id: `btn${item.Name}`,
        'data-alias': formProp.Alias,
        'data-control': `ctrl${item.Name}`,
        'data-dmclassName': item.DMClassName,
        'data-id': `ctrl${item.Name}`,
        'data-KeyFieldControls': item.KeyFieldControls,
        'data-LinkLookupDataSetNome': item.LinkLookupDataSetNome,
        'data-LinkLookupKeyFields': item.LinkLookupKeyFields,
        'data-LinkKeyFields': item.LinkKeyFields,
        'data-LinkLookupMultiSelecao': item.LinkLookupMultiSelecao,
        'data-LinkLookupResultField': item.LinkLookupResultField,
        'data-NomesValores': item.NomesValores,
        'data-original-title': "Incluir um Novo",
        'data-target': "#myModal",
        'data-toggle': "modal",
    });

    return button;
}

const getButtonSearchClassList = (item: Field) => {
    let def = 'input-group-text btn btn-text-dark btn-hover-transparent-dark btn-sm';
    let searchStyle = item.SearchStyle ? 'input-append-blue border-radius-right' : '';

    return `${def} ${searchStyle}`.trim();
}