import { ConteudoConfig } from "../../../types/page-config/page-config";

interface DropdownReportItemProps { 
    Conteudo: ConteudoConfig;
}

export const dropdownReportButton = ({ Conteudo }: DropdownReportItemProps) => {
    const { Origem = '', ArquivosRelatorio } = Conteudo;
    const dropdownMenu = $('<ul class="dropdown-menu w-100" >');
    const item = $(`
        <li class="navi-item dropdown-submenu pull-left">
            <a class="navi-link" style="cursor: pointer;" title="Lista de relatórios">
                <i class="navi-text navi-icon la la-angle-down"></i>
                <span class="navi-text">Exportar</span>
            </a>
        </li>`).on('mouseover', () => {
            const { height, top } = dropdownMenu.get(0).getBoundingClientRect();
            const windowHeight = window.visualViewport.height;
            const treshold = height + top - windowHeight + 10;

            if (treshold > 0) dropdownMenu.css('top', `-${treshold}px`);
        });

    const submenuItems = ArquivosRelatorio!.map(({ Temp, Arquivo, Tipo, CaptionTipo }) => {
        const li = $(`
            <li class="navi-item">
                <a 
                    class="navi-link"
                    href="${Temp
                        ? `ArquivoTemp/${Arquivo}`
                        : `ConverteRelatorio?${Tipo}\\${Origem}}`
                    }"
                >
                    <span class="navi-text">${CaptionTipo}</span>
                </a>
            </li>   
        `);

        return li;
    });
    
    dropdownMenu.append(submenuItems);
    
    return item.append(dropdownMenu);
};
