import { DefinicaoObjetosConfig } from "../../../types/page-config/page-config";
import { getStringDataAction } from "../util/action-data";

interface ExecuteButtonProps {
    DefinicaoObjetos: Pick<DefinicaoObjetosConfig, 'Class' | 'Alias' | 'CadCons' | 'TopicoAjuda'>;
}

export const ExecuteButton = ({ DefinicaoObjetos: { Class, Alias = '', CadCons, TopicoAjuda } }: ExecuteButtonProps) => {
    return $(
        `<button class="btn btn-dark ml-4 py-2" 
                id="btnFiltrar" 
                type="button" 
                data-formid="frmParametros"
                data-n-onclick="ActionExecutarExecute"
                ${getStringDataAction(Class, Alias, CadCons, TopicoAjuda)}> 
            <span class="h4 font-weight-normal text-uppercase">
                Executar 
            </span>
        </button>`
    );
};