import { DefinicaoObjetosConfig } from "../../../types/page-config/page-config";

interface FieldChooserButtonProps {
    DefinicaoObjetos: Pick<DefinicaoObjetosConfig, 'FormDetalhe' | 'Class' | 'Alias' | 'CadCons' | 'TopicoAjuda' | 'Pages' | 'Fields'>;
}

export const FieldChooserButton = ({ DefinicaoObjetos: { FormDetalhe, Class, Alias, CadCons, TopicoAjuda, Pages, Fields } }: FieldChooserButtonProps) => {
    const li = $(`<li class="kt-portlet__nav-item" data-class="${Class}" data-alias="${Alias}" data-cadcons="${CadCons}" data-topicoajuda="${TopicoAjuda}" style="display: inline">`);
    const btnGroup = $(
        `<div class="btn-group" id="fieldChooser${Class}${Alias}" data-id="fieldChooser" data-class="${Class}" data-alias="${Alias}" data-cadcons="${CadCons}" data-topicoajuda="${TopicoAjuda}">
            <button type="button" class="btn btn-sm btn-text-dark btn-hover-transparent-dark  kt-btn dropdown-toggle py-2 ml-2" data-toggle="dropdown">
                <i class="la la-list"></i>
            </button>
        </div>`
    );

    const dropdown = $(`<div class="dropdown-menu dropdown-menu-right" style="width: 300px;">`);
    const dropdownList = $(`<ul class="kt-nav">`).data({
        'pages': !FormDetalhe ? Pages : null,
        'fields': Fields,
        'class-name': Class,
        'alias': Alias,
    });

    dropdown.append(dropdownList);

    btnGroup.append(dropdown);

    return li.append(btnGroup);
}
