import { DefinicaoObjetosConfig } from "../../../types/page-config/page-config";
import { getStringDataAction } from "../util/action-data";

interface SaveButtonProps {
    DefinicaoObjetos: Pick<DefinicaoObjetosConfig, 'Class' | 'CadCons' | 'TopicoAjuda' | 'Alias' | 'ToolButtons'>;
}

export const SaveButton = ({ DefinicaoObjetos: { Class, CadCons, TopicoAjuda, Alias = '', ToolButtons } }: SaveButtonProps) => {
    const { disabled } = ToolButtons.find(({ Name }) => Name === 'actDataSetPost')!;

    return $(
        `<li class="kt-portlet__nav-item" data-class="${Class}" data-alias="${Alias}" data-cadcons="${CadCons}" data-topicoajuda="${TopicoAjuda}" style="display: inline">
            <div class="btn-group" data-class="${Class}" data-alias="${Alias}" data-cadcons="${CadCons}" data-topicoajuda="${TopicoAjuda}">
                <button type="button" class="btn btn-text-dark btn-hover-transparent-dark py-2 ml-2" id="btnActDataSetPostExecute${Class}${Alias}" data-posttype="1" href="#" ${disabled ? 'disabled data-disabled="true"' : ''}
                    data-n-onclick="actDataSetPostExecute" 
                    ${getStringDataAction(Class, Alias, CadCons, TopicoAjuda)}
                >
                    <i class="las la-save"></i> 
                    <span class="h4 font-weight-normal text-uppercase"> Salvar </span> 
                </button>                
                <button 
                    type="button"
                    class="btn btn-text-dark btn-hover-transparent-dark btn-sm btn-accent dropdown-toggle dropdown-toggle-split kt-btn"
                    id="btnActDataSetPostExecuteOpts${Class}${Alias}"
                    ${disabled ? 'disabled' : ''}
                    data-toggle="dropdown"
                    aria-expanded="false"
                    aria-haspopup="true"
                    data-display="static"
                >
                </button>
                <div class="dropdown-menu dropdown-menu-right">
                    <a id="btnpost0" class=" dropdown-item" data-posttype="0" href="javascript:;" data-n-onclick="actDataSetPostExecute" ${getStringDataAction(Class, Alias, CadCons, TopicoAjuda)}> <!-- onclick="actDataSetPostExecute(this)" -->
                        <i class="la la-plus"> </i>
                        <span class="kt-nav__link-text">Salvar e Abrir Novo</span>
                    </a>
                    <a id="btnpost1" class=" dropdown-item" data-posttype="1" href="javascript:;" data-n-onclick="actDataSetPostExecute" ${getStringDataAction(Class, Alias, CadCons, TopicoAjuda)}> <!-- onclick="actDataSetPostExecute(this)" -->
                        <i class="la la-pen"> </i>
                        <span class=""> Salvar e Editar </span>
                    </a>
                    <a id="btnpost2" class=" dropdown-item" data-posttype="2" href="javascript:;" data-n-onclick="actDataSetPostExecute" ${getStringDataAction(Class, Alias, CadCons, TopicoAjuda)}> <!-- onclick="actDataSetPostExecute(this)" -->
                        <i class="la la-copy"> </i>
                        <span class=""> Salvar e Duplicar </span>
                    </a>
                    <a id="btnpost3" class=" dropdown-item" data-posttype="3" href="javascript:;" data-n-onclick="actDataSetPostExecute" ${getStringDataAction(Class, Alias, CadCons, TopicoAjuda)}> <!-- onclick="actDataSetPostExecute(this)" -->
                        <i class="la la-undo"> </i>
                        <span class=""> Salvar e Voltar </span>
                    </a>
                    <div class="dropdown-divider"> </div>
                    <a class=" dropdown-item" data-posttype="4" href="javascript:;" data-n-onclick="actDataSetCancelExecute"  ${getStringDataAction(Class, Alias, CadCons, TopicoAjuda)}> <!-- onclick="actDataSetCancelExecute(this)" -->
                        <i class="la la-undo-alt"> </i>
                        <span class=""> Desfazer </span>
                    </a>
                </div>
            </div>
        </li>`
    );
};