import { TwArquivosTempConfig, WidgetPropsBase } from "../types";

interface TwArquivosTempConfigProps extends Omit<WidgetPropsBase, 'card' | 'config'> {
    widget: TwArquivosTempConfig;
}

export const TwArquivosTemp = ({ widget: { ArquivosTemp, Name }}: TwArquivosTempConfigProps) => $(
    `<div id="widget_${Name}" class="row">
        <div class="col">
            <div class="card card-custom kt-portlet--bordered kt-portlet--rounded kt-portlet--unair kt-portlet--head-sm mt-4">
                <div class="card-header">
                    <h3 class="h2 card-title">
                        Arquivos
                    </h3>
                </div>
                <div class="card-body" id="ArquivosTemp">
                    ${ArquivosTemp.map(({ Arquivo, Caption }) => {
                        if (Arquivo.trim() === '') return '';

                        return `<a href="ArquivoTemp/${Arquivo}" class="btn btn-dark" data-toggle="kt-tooltip" title='Download do arquivo "${Caption}"' download>
                                    <span>
                                        <i class="la la-cloud-download kt--font-info"></i>
                                        <span>${Caption}</span>
                                    </span>
                                </a>`;
                    })}		
                </div>
            </div>
        </div>
    </div>`
);
