import { DynamicImport } from "../../../../js/Utils/DynamicImport"
import { DefinicaoObjetosConfig } from "../../../types/page-config/page-config";
import { TwButtonControlConfig } from "../types";

interface Props {
    element: JQuery<HTMLElement>;
    widget: TwButtonControlConfig;
    DefinicaoObjetos: Pick<DefinicaoObjetosConfig, 'Class' | 'Alias' | 'TipoObjeto'>;
}

export const createTwButtonControl = async ({ element, widget, DefinicaoObjetos }: Props) => {
    const { buildWidget } = await DynamicImport.Import('Widgets/twButtonControl/twButtonControl.component');

    return buildWidget({
        element,
        DefinicaoObjetos,
        scope: widget,
    }) as JQuery<HTMLElement>;
};