import FormManager from "../../../../js/FormManager";
import { DefinicaoObjetosConfig } from "../../../types/page-config/page-config";
import { NavigateWizard } from "../../wizard-navigation/wizard-navigation";
import { TwButtonConfig, WidgetPropsBase } from "../types";

interface TwButtonProps extends Omit<WidgetPropsBase, 'card' | 'config'> {
    widget: TwButtonConfig;
    DefinicaoObjetos: Pick<DefinicaoObjetosConfig, 'Alias' | 'Class'>;
}

export const TwButton = ({ widget, DefinicaoObjetos }: TwButtonProps) => {
    const { Name, Action, Text } = widget;
    const { Class, Alias = '' } = DefinicaoObjetos;

    const buttonWrapper = $(`
        <div id="widget_${Name}" class="btn-process-action-wrapper">
            <div class="widget-thumb-wrap">
                <div class="additional-buttons mt-4">
                </div>
            </div>
        </div>
    `);

    const button = $(`
        <button 
            class="btn btn-primary btn-sm kt-btn--wide mb-4"               
            data-action='${Action}' 
            data-name='${Name}'
            id="widget_title_${Name}"
            type="button" 
        >${Text}</button>
    `);

    buttonWrapper.find('.additional-buttons').append(button);

    if (Action) {
        button.on('click', () => {
            NavigateWizard({
                actionname: Action,
                sender: `widget.${Name}`,
                form: FormManager.byname(Class, Alias),
            });
        });
    }

    return button;
};