import dxDataGrid from 'devextreme/ui/data_grid';

export const disposeTwCxGrid = ({ gridId, wrapperId}: { gridId?: string, wrapperId?: string }) => {
    if (gridId) {
        getGridByElement($(`#${gridId}`))?.dispose();
    }
    else if (wrapperId) {
        $(`#${wrapperId}`)
            .find('[id*="dataGridConteudo"]')
            .each((_, el) => {
                getGridByElement($(el))?.dispose();
            });
    }
};

const getGridByElement = (element: JQuery<HTMLElement>) => {
    try {
        return dxDataGrid.getInstance(element);
    }
    catch (e) {
        console.error(e)
        return null;
    }
};