import { TwImageTextConfig, WidgetPropsBase } from "../types";

interface TwImageTextProps extends Omit<WidgetPropsBase, 'card' | 'config'> {
    widget: TwImageTextConfig;
}

export const TwImageText = ({ widget: { colunas, Name, image, TextColor, Text, Data }}: TwImageTextProps) => $(`
    <div id="widget_${Name}" class="${colunas ? `col-${colunas}` : ''}">
        <a class="" href="#">
            <div class="widget-thumb widget-bg-color-white text-uppercase" style="padding:5px;">
                <div class="widget-thumb-wrap">
                <i class="widget-thumb-icon btn-warning"
                    style="background-image:url('data:image/png;base64,${image}');width:10px;height:10px"
                    id="widget_image_${Name}"></i>
                <div class="widget-thumb-body">
                    <span class="widget-thumb-body-stat" data-counter="counterup" data-value="${Data}"
                    style="font-size:10px;color:#${TextColor}" id="widget_title_${Name}">${Text}</span>
                </div>
                </div>
            </div>
        </a>
    </div>
`);