import { TwListaConfig, WidgetPropsBase } from "../types";

interface TwListaProps extends Omit<WidgetPropsBase, 'card' | 'config'> {
    widget: TwListaConfig;
}

export const TwLista = ({ widget }: TwListaProps) => {
    const { colunas, CorTitulo, Itens, Name, Text } = widget;
    
    return $(`
        <div id="widget_${Name}" class="kt-widget1__item ${colunas ? `col-${colunas}` : 'col'}" style="padding:1.0rem;border-bottom:none">
            <div class="col-md-12">
                <a id="widget_title_${Name}" href="#" class="kt-dropdown__toggle btn btn-success"
                    style="margin-bottom: 11px;border-color:var(--${CorTitulo});background-color:var(--${CorTitulo});">
                    ${Text}
                </a>
                <div style="box-sizing: border-box;background:white;border:4px solid #f7f7fa;padding:30px;">
                    <div id="widget_itens_${Name}" class="timeline timeline-2">
                        ${Itens
                            .map(({ Caption, Valor }) => `
                                <div class="timeline-item">
                                    <span class="timeline-badge bg-success"></span>
                                    <div class="timeline-content d-flex align-items-center justify-content-between">
                                        <span class="mr-3">${Caption}</span>
                                        <span class="text-right">${Valor}</span>
                                    </div>
                                </div>
                            `.trim())
                            .join('')
                        }
                    </div>
                </div>
            </div>
        </div>
    `);
}