import { DefinicaoObjetosConfig } from "../../../types/page-config/page-config";
import { Card } from "../layout/card";
import { FloatingMenuItems } from "../layout/floating-menu";
import { Layout, LayoutOptions } from "../layout/layout";
import { TwMasterDetailConfig } from "../types";

interface TwMasterDetailProps {
    widget: TwMasterDetailConfig;
    detailsConfig: DefinicaoObjetosConfig[]; //DefinicaoDetalhes
    floatingMenuItems?: FloatingMenuItems;
    card?: Card;
    options?: LayoutOptions;
}

export const TwMasterDetail = ({ widget, detailsConfig, card, floatingMenuItems, options }: TwMasterDetailProps) => {
    const detail = detailsConfig.find((e: any) => e.Class == (widget as TwMasterDetailConfig).DetailClass)!;
    const div = Layout.initLayout({
        scope: {
            Class: detail.Class,
            DefinicaoObjetos: detail,
        },
        card,
        floatingMenuItems,
        options: {
            ...options,
            isFrom: {
                ...options?.isFrom,
                twMasterDetail: true,
            }
        },
    });

    if (!div) throw new Error('TwMasterDetail layout failed, no element returned');

    return div;
};