import { TwMsgListaConfig, WidgetPropsBase } from "../types";

interface TwMsgListaProps extends Omit<WidgetPropsBase, 'card' | 'config'> {
    widget: TwMsgListaConfig;
}

export const TwMsgLista = ({ widget: { Name, MsgLista: { Columns, Items, datatablesettings } } }: TwMsgListaProps) => {
    const table = $(
        `<table id="widget_${Name}" class="display table kt-table kt-table--head-no-border">
            <thead>
                <tr>
                    ${
                        Columns
                            .map((column) => `<th>${column}</th>`)
                            .join('')
                    }
                </tr>
            </thead>	  
            <tbody>
                ${
                    Items
                        .map((values) => {
                            return `<tr>${
                                        values
                                            .map((value = '') => `<td>${value}</td>`)
                                            .join('')
                                    }</tr>`
                        })
                        .join('')
                }
            </tbody>
        </table>`
    );
   
    if (datatablesettings) {
        //@ts-ignore
        table.DataTable(datatablesettings)
    }
    
    return table;
}
