import { TwTextConfig, WidgetPropsBase } from "../types";

interface TwTextProps extends Omit<WidgetPropsBase, 'card' | 'config'> {
    widget: TwTextConfig;
}

export const TwText = ({ widget: { colunas, Align, Text, TextColor, Name, Action = '', Classe = '' } }: TwTextProps) => $(
    `<div 
        class="widget-item ${colunas ? `col-${colunas}` : ''}" 
        ${Align === 'twaNone' ? 'style="flex-direction: column;"' : ''}
    >
        <div class="row align-items-center">
            <div class="col">
                <h3 
                    class="font-size-h1 widget-title" 
                    id="widget_title_${Name}"
                    style="color: #${TextColor}" 
                    ${Action 
                        ? `onclick="${Action}('${Classe}');" style="cursor: pointer;"`
                        : ''
                    }
                >${Text}</h3>
            </div>
        </div>
    </div>`  
);