import { CarregarTreeList } from "../../../../js/treeview/treeview";
import { TwTreeViewConfig, WidgetPropsBase } from "../types";

interface TwTreeViewProps extends Omit<WidgetPropsBase, 'card' | 'config'> {
    widget: TwTreeViewConfig;
}

export const TwTreeView = ({ widget }: TwTreeViewProps) => {
    const { 
        nTreeView,
        Name, 
        colunas, 
        image,
        Text = 'Resultados',
    } = widget;
    
    const wrapper = $(
        `${colunas ? '' : `<div id="widget_${Name}" class="row">`}
            <div ${colunas ? `id="widget_${Name}"` : ''} class="p-3 border-bottom-0 ${colunas ? `col-${colunas}`: 'col'}" style="align-items: normal">
                <div class="card card-custom  mt-4">
                    <div class="card-header">
                        <div class="card-title">
                            <span class="card-icon">
                                <i   
                                    ${
                                        image
                                            ? `class="widget-thumb-icon btn-warning float-left d-inline-block"
                                                style="width: 20px;height: 20px;font-size: 20px;line-height:41px;color: #fff;text-align: center;padding: 1px;margin-right: 6px;background-size:cover;background-image:url('data:image/png;base64,${image}')"`
                                            : 'class="fa fa-tag"'
                                    }
                                    id="widget_image_${Name}"
                                ></i>
                            </span>
                            <h3 id="widget_title_${Name}" class="card-label">${Text}</h3>
                        </div>
                    </div>
                    <div class="card-body"></div>
                </div>

            </div>
        ${colunas ? '' : '</div>'}`
    );

    const divTree = $(`<div id="widget_tree_${Name}">`).data({
        treeContent: nTreeView || [],
    });

    wrapper.find('.card-body').append(divTree);

    CarregarTreeList(null, divTree);

    return wrapper;
}
