import widgetManager from "../widget-manager";
import { TwValueDisplayerConfig, WidgetPropsBase } from "../types";
import { WidgetWithExpression } from "../widget-with-expression";

interface TwValueDisplayerProps extends Omit<WidgetPropsBase, 'card' | 'config'> {
    widget: TwValueDisplayerConfig;
    Class: string;
}

export class TwValueDisplayer extends WidgetWithExpression<TwValueDisplayerConfig, TwValueDisplayerProps> {
    constructor(config: TwValueDisplayerProps) {
        super(config);

        widgetManager.set(config.widget.Name, this);
    }

    protected _expressionValueSetValue(value: string): void {
        this.setValue({ Valor: value });
    }

    protected _build(): JQuery<HTMLElement> {
        const { widget: { colunas, Estilo, Name, Text, TextColor, Valor } } = this.getState();

        return $(
            `<div id="widget_${Name}" class="${colunas ? `col-sm-6 col-lg-${colunas}` : 'col'}">
                <a class="dashboard-stat dashboard-stat-v2 ${Estilo}" href="#">
                <div class="visual">
                    <i class="fa fa-chevron-circle-up "></i>
                </div>
                <div class="details">
                    <div class="number" id="widget_valor_${Name}" style="color:#${TextColor}">${Valor}</div>
                    <div class="desc" id="widget_title_${Name}" style="color:#${TextColor}"> ${Text} </div>
                </div>
                </a>
            </div>`
        );
    }
}
