import { PageConfig } from "../../../types/page-config/page-config";
import { Field, GroupColumn } from "../../fra-control/types"
import { isGroupColumn } from "../../fra-control/util/util";

type MappedFields = [string, (Field | GroupColumn)];

const mapFieldsArray = (fields: (Field | GroupColumn)[] = []): MappedFields[] => {
    return fields.map((field) => {
        if (isGroupColumn(field)) {
            throw new Error('twFieldList doesn\'t support GrupoColuna');
        }

        return [field.Name, field];
    })
};

const mapPageFields = (fields: PageConfig[] = []): MappedFields[] => {
    const keyFields = fields.reduce((fields, item) => {
        return [
            ...fields,
            ...mapFieldsArray(item.Fields),
        ]
    }, [] as MappedFields[]);

    return keyFields;
}

export const mapFields = (masterFields: (Field | GroupColumn)[] = [], page: PageConfig[] = []): Map<string, (Field | GroupColumn)> => {
    return new Map([
        ...mapPageFields(page),
        ...mapFieldsArray(masterFields)
    ]);
}