import { Widget, WidgetsConfig } from "../types";

type MappedItem = [string, Widget];

export const mapWidgets = (widgets: WidgetsConfig): Map<string, Widget> => {
    const prepareItemNewMap = (items: Widget[]): MappedItem[] => items.map((item) => [item.Name, item]);

    const items = Object
        .values(widgets)
        .reduce((items, position) => {
            const mappedItems = position.reduce((array, item) => [
                ...array,
                ...prepareItemNewMap(item.Itens)
            ], [] as MappedItem[]);

            return [
                ...items,
                ...mappedItems
            ];
        }, [] as MappedItem[]);

    return new Map(items);
}