import { getEdocFields } from "./envio-edoc/edoc-fields";
import { getQColaboreFields } from "./envio-qcolabore/qcolabore-fields";
import { ReportTypeZen } from "./envio-zen";

export interface GetFieldsProps {
    ClassName: string;
    Accordion: string;
    ReportType: ReportTypeZen;
    Definicao: {
        Categoria: string;
        Formato: string;
    };
}

export const getFields = (props: GetFieldsProps) => {
    const { ReportType } = props;

    switch (ReportType) {
        case 'edoc': return getEdocFields(props);
        case 'qcolabore': return getQColaboreFields(props);
        default: return [];
    }
};