import { ScopeConfig } from "../../types/page-config/page-config";

interface OpenPdfProps extends Pick<ScopeConfig, 'DefinicaoObjetos' | 'Params'> {
    fileName: string;
    fileNameNhz: string;
}

export const openPdf = ({ DefinicaoObjetos, fileName, fileNameNhz, Params }: OpenPdfProps) => {
    const { Class, ToolButtons, TipoObjeto, TopicoAjuda } = DefinicaoObjetos;

    const params = {
        fileName,
        fileNameNhz,
        Params,
        DefinicaoObjetos: {
            Class,
            ToolButtons,
            TipoObjeto,
            TopicoAjuda,
        },
    };

    window.open(`RelatorioExibir?Scope=${encodeURIComponent(btoa(JSON.stringify(params)))}`);
};
