const path = require('path');
const WebpackNotifierPlugin = require('webpack-notifier');
const BundleAnalyzerPlugin = require('webpack-bundle-analyzer').BundleAnalyzerPlugin;
const TerserPlugin = require('terser-webpack-plugin');
const dotenv = require('dotenv');

dotenv.config({path: 'development.env'})

module.exports = {
	mode: 'development',
	devtool: 'source-map',
	optimization: {
		minimizer: [
			new TerserPlugin({
				parallel: true
			})
		]
	},
	plugins: [
		new WebpackNotifierPlugin({
			title: 'Cloud webpack',
			contentImage: path.join(__dirname, 'images/logo_questor_q-g.png'),
			excludeWarnings: true,
		}),
		new BundleAnalyzerPlugin({
			analyzerMode: process.env.BUNDLE_ANALYZER_MODE,
			reportFilename: process.env.BUNDLE_ANALYZER_RESULT_NAME + ".html"
		})
	]
};